#ifndef CHARDDEFS
#define CHARDDEFS

#include "MeteoTools.h"
#include "linedefs.h"

#pragma pack(1)
#define USHORT unsigned short
#define UBYTE unsigned char

///////////////// METEO ****************************METEO /////////////////



#define K2SIZ       80
#define STSIZ       20


typedef struct	
		{
		DWORD		MeteoRaster;
		time_t		time_range;
		COLORREF	PTCol;			//Druck Textcolor
		COLORREF	PFCol;			//Druck Framecolor
		COLORREF	TTCol;			//Temperatur Textcolor
		COLORREF	TFCol;			//Temperatur Framecolor
		COLORREF	WTCol;			//Wind Textcolor
		COLORREF	WFCol;			//Wind Framecolor
		LOGFONT		SymbolFont;
		double		screenscale;	//Nav_Map Bildshirm Skalierung
		double		lmapxoff;		//Nav_Map X-Offset
		double		lmapyoff;		//Nav_Map X-Offset
		}METEOCFG;


//////////////// CHARTS *********************** CHARTS ///////////////////////

#define LINE_CODE_FILL		0x80	      //Fill on / off
#define LINE_CODE_CLOSELOOP	0x20	      //Close Line-Loop
#define LINE_CODE_BORDER	0x10	      //Line hat eine Border
#define LINE_CODE_RAST		0x08	      //Feines Raster bilden
#define LINE_CODE_LINE		0x04	      //Grobes Raster bilden

#define OBJ_LOGO	0
#define OBJ_WOLKE	1
#define OBJ_SONNE	2
#define OBJ_REGEN	3
#define OBJ_HAGEL	4
#define OBJ_GEWITTER 5
#define OBJ_SCHNEE	6
#define OBJ_WOLKESONNE 7





//
// info_flag_1 >> 4
//
//Line_1 ********  **	**  *******		Border
//Line_2 ***  ***  ***					gepunktet
//Line_3 *****   *****					gestrichelt
//Line_4 *******      *******			lang gestrichelt
//Line_5 **   **   **					dick gepunktet
//Line_6 ******  ******  ******			dick gestrichelt
//Line_7 ********	********			dick lang gestrichelt
//Line_8 _______________________		Line_ einfache dicke Linie


#define	LINE_SCAT_BORDER			1	//PS_DASHDOTDOT
#define	LINE_SCAT_PUNKT				2   //PS_DOT
#define	LINE_SCAT_STRICH			3	//PC_DASH
#define	LINE_SCAT_LANGSTRICH		4	//PC_DASHDOT
#define	LINE_SCAT_DICKPUNKT			5	//2xPC_DOT
#define	LINE_SCAT_DICKSTRICH		6	//2xPC_DASH
#define	LINE_SCAT_DICKLANGSTRICH	7	//2xPC_DASHDOT
#define	LINE_SCAT_LINE				8   //PC_SOLID


#define RGB_MENUBACK	RGB(192,192,192)	//0
#define RGB_MENUDUNKEL	RGB(0,0,0)			//1
#define RGB_SCHWARZ 	RGB(0,0,0)			//1
#define RGB_MENUHELL	RGB(255,255,255)	//2
#define RGB_WEISS		RGB(255,255,255)	//2	
#define RGB_MENUGRAU	RGB(128,128,128)	//3
#define RGB_BLAU		RGB(24,24,168)		//4
#define RGB_GELB		RGB(255,216,0)		//5
#define RGB_BLAUGRAU	RGB(0,0,208)		//6
#define RGB_MENURAST	RGB(112,114,168)	//7
#define RGB_CYANBLAU	RGB(0,80,224)		//8
#define RGB_GRUEN		RGB(0,208,0)		//9
#define RGB_CYAN		RGB(0,128,255)		//10
#define RGB_VIOLETT 	RGB(255,0,255)		//11
#define RGB_DUNKELGRUEN	RGB(40,136,96)		//12
#define RGB_ROT			RGB(255,40,0)		//13
#define RGB_BRAUN		RGB(144,96,0)		//14
#define RGB_HELLBRAUN	RGB(168,128,0)		//15

#define PRINTER_00 RGB(192,192,192)
#define PRINTER_01 RGB(0,0,0)
#define PRINTER_02 RGB(0,0,0)
#define PRINTER_03 RGB(240,255,255)
#define PRINTER_04 RGB(255,255,255)
#define PRINTER_05 RGB(256,216,0)
#define PRINTER_06 RGB(96+32,200+32,216)
#define PRINTER_07 RGB(112,114,168)
#define PRINTER_08 RGB(88,224,232)
#define PRINTER_09 RGB(0,208,0)
#define PRINTER_10 RGB(192,255,255)
#define PRINTER_11 RGB(255,0,255)
#define PRINTER_12 RGB(114,176,48)
#define PRINTER_13 RGB(255,40,0)
#define PRINTER_14 RGB(255,200,100)
#define PRINTER_15 RGB(200,104,0)


//set the colors of bathemetry
#define PAL_COL_SEA		myColors[0].bathy
#define PAL_COL_LAND	myColors[1].bathy
#define PAL_COL_RIVER	myColors[2].bathy
#define PAL_COL_COUNTRY	myColors[3].bathy
#define PAL_COL_TIDE	myColors[4].bathy
#define PAL_COL_BORDER	myColors[5].bathy
#define PAL_P_BORDER	myColors[6].bathy
#define PAL_P_LAND		myColors[7].bathy
#define PAL_P_RIVER		myColors[8].bathy
#define PAL_P_FRAME		myColors[9].bathy

//the same specials for drawing tolls examble
#define PAL_COL_SEA		myColors[0].bathy
#define PAL_COL_LAND	myColors[1].bathy
#define PAL_COL_RIVER	myColors[2].bathy
#define PAL_COL_COUNTRY	myColors[3].bathy
#define PAL_COL_TIDE	myColors[4].bathy
#define PAL_COL_BORDER	myColors[5].bathy
#define PAL_P_BORDER	myColors[6].bathy
#define PAL_P_LAND		myColors[7].bathy
#define PAL_P_RIVER		myColors[8].bathy
#define PAL_P_FRAME		myColors[9].bathy


#define MAP_COL_SEA		RGB(239,243,214)	//default color of pressure
#define MAP_COL_LAND	RGB(193,194,150)
#define MAP_COL_RIVER	RGB(131,184,177)
#define MAP_COL_COUNTRY	RGB(239,243,214)
#define MAP_COL_TIDE	RGB(216,237,201)
#define MAP_COL_BORDER	RGB(239,243,214)
#define MAP_P_BORDER	RGB(128,128,128)
#define MAP_P_LAND		RGB(154,135,61)	
#define MAP_P_RIVER		RGB(75,152,188)
#define MAP_P_FRAME		RGB(0,60,70)


#define MENUBACK	0
#define MENUDUNKEL	1
#define SCHWARZ 	1
#define MENUHELL	2
#define WEISS		2
#define MENUGRAU	3
#define BLAU		4
#define GELB		5
#define BLAUGRAU	6
#define MENURAST	7
#define CYANBLAU	8
#define GRUEN		9
#define CYAN		10
#define VIOLETT 	11
#define DUNKELGRUEN	12
#define ROT			13
#define BRAUN		14
#define HELLBRAUN	15



struct POINT_NEWLINE
{
	long		lat;		    //LINE-Y-Position
	long		lon;		    //LINE-X-Position
};
	
struct COORDINAT_WIN
{
	long		ymin;		//obere linke Y-Koordinate
	long		xmin;		//obere linke X-Koordinate
	long		ymax;		//untere rechte Y-Koordinate
	long		xmax;		//untere rechte X-Koordinate
};

struct CHART_HDR
{
	struct COORDINAT_WIN	frame;				//Kartenrahmen
	long					seek_window[11];	//Seekpositionen im WPN-File
	long					text_seekpos;		//Seek-Position im Kommentar-File
};

struct POINT_WIN	//FILE.WPN  Header-Strucktur-File fr eine Linie oder ein Poligon 
{
	long		ymin;				//TOP-Y-Position fr das Rechteck des Objektes  
	long		xmin;				//TOP-X-Position
	long		ymax;				//BOT-Y-Position
	long		xmax;				//BOT-X-Position
	long		coor_file_seekpos;	//Source-File (FILE.LIN) Seek-Positions-Zeiger 
	USHORT		read_len;			//READ_LINE-Len evt. bei kompremierten Linien
	USHORT		len;				//LINE-Len  wirkliche Lnge
	UBYTE		info_flag_1;		//LINE-_info_Flag
	UBYTE		info_flag_2;		//LINE-_info_Flag
};

struct CHART
{
	struct CHART_HDR		hdr;			//Karten Header
	struct COORDINAT_WIN	window; 		//momentaner Ausschnitt
	double					visit_scale;	//ab dieser Scale sichtbar
	short					flag_1; 		//diverse Flags
	short					flag_2; 		//diverse Flags
	UBYTE					intern_flag;	//diverse Flags
	char					filename[9];	//Karten Filename
};

#pragma pack()
#endif