#include "stdafx.h"
#include "lineDefs.h"
#include "chartdefs.h"
#include "resource.h"
#include "MeteoTools.h"
#include "ChartDefs.h"

#define FELDMAX			2000
#define RAD				(0.017453292519943296)	//(PI / 180.)	
#define MINMAX(a,b,c)	((a)<(b))?(a=b):(((a)>(c))?(a=c):(a)) // a ist minimal b und maximal c

class CMeteoView		*myMeteoView=NULL;
class CMainFrame		*myMainFrm=0;

SYN_DATA				LastStation;
CPoint					PointOBuf[1024];
struct POINT_NEWLINE	PointIBuf[4096];
struct LinePoint		*SPointIbuf;
int						DetailFlags=SYNOP_WIND|SYNOP_TEMP|SYNOP_PRESS|SYNOP_CLOUDS;
int						SynopDetailFlags=FIG_ISO_BAR|LAY_PRECI|LAY_TEMP|LAY_CLOUDS;
int						MeteoDataSelection=1;
int						m_UTC=0;
int						MouseDown=0,m_folder=FDIR_BANK1,m_index=0;
char					*RegionStr[]={"USR","WRL","EUR","MID","USA","EST","AFR","IND","AUS"};

char					myDIR[512];
HCURSOR					myPicDropOK,myPicNoDrop;
int						N_SynArray=0;

/////////////////////////////////////////////////////////////////////////////////////////
//GetProfile, WriteProfile is only for MeteoCom compatible test - this is not importand
/////////////////////////////////////////////////////////////////////////////////////////
int WINAPI GetMyProfileInt(char *AppName, char *KeyName, int value)
{
	return AfxGetApp()->GetProfileInt(AppName,KeyName,value);
}

BOOL WINAPI WriteMyProfileInt(char *AppName, char *KeyName, int value)
{
	return AfxGetApp()->WriteProfileInt(AppName,KeyName,value);
}

double WINAPI GetMyProfileDouble(char *AppName, char *KeyName, double value)
{
	CString		str,val;

	val.Format("%f\0",value);
	str=AfxGetApp()->GetProfileString(AppName,KeyName,val);
	return atof(str);
}

BOOL WINAPI WriteMyProfileDouble(char *AppName, char *KeyName, double value)
{
	CString		val;
	val.Format("%f\0",value);
	return AfxGetApp()->WriteProfileString(AppName,KeyName,val);
}
/////////////////////////////////////////////////////////////////////////////////////////




METEOCFG	MeteoCfg=
{
			     RGB(79,49,0),  //Air Pressure Textcolor
			 RGB(240,255,168),  //Air Pressure Framecolor
				RGB(109,79,0),  //Temperatur Textcolor
			 RGB(240,255,168),  //Temperatur Framecolor
			      RGB_SCHWARZ,  //Wind Textcolor  
			 RGB(255,255,128),  //Wind Framecolor
			     RGB_BLAUGRAU,  //Wave Textcolor  
			     RGB_CYANBLAU,  //Wave Framecolor
							{	//SymbolFont
						   -10,	//lfHeight;
							0,	//lfWidth;
							0,	//lfEscapement;
							0,	//lfOrientation;
					 FW_BOLD,	//lfWeight;
							0,	//lfItalic;
							0,	//lfUnderline;
							0,	//lfStrikeOut;
							0,	//lfCharSet;
							0,	//lfOutPrecision;
							0,	//lfClipPrecision;
							0,	//lfQuality;
	  FIXED_PITCH | FF_MODERN,	//lfPitchAndFamily;
				{"MS Sans Serif\0"}},	//lfFaceName[LF_FACESIZE];
						  7.,	//Nav_Map Skalierung
						2800.,	//Nav_Map X-Offset
						2800.
};
   
   

COLORREF planecol[]=
		{			
		MAP_COL_SEA,		//plane[0]=DEPTH_CONTOUR	6
		MAP_COL_SEA,		//plane[1]=DEPTH_CONTOUR	8
		MAP_COL_SEA,		//plane[2]=DEPTH_CONTOUR	10
		MAP_COL_TIDE,		//plane[3]=INTERTIDAL_AREA	12
		MAP_COL_LAND,		//plane[4]=LAND				14
		MAP_COL_SEA,		//plane[5]=LAKE				6
		MAP_COL_BORDER,		//plane[6]=CITY				15
		MAP_COL_RIVER,		//plane[7]=RIVER			6
		RGB(255,0,255),		//plane[8]=SEABORDERS		11
		MAP_COL_COUNTRY,	//RGB_HELLBRAUN,		//plane[9]=STATE/COUNTRY	15
		RGB(255,40,0),			//plane[10]=				13
		0,
		0,
		0,
		0,
		0,
		PRINTER_06,			//RGB_BLAUGRAU,		//plane[0]=DEPTH_CONTOUR	6
		PRINTER_08,			//RGB_CYANBLAU,		//plane[1]=DEPTH_CONTOUR	8
		PRINTER_10,			//RGB_CYAN,			//plane[2]=DEPTH_CONTOUR	10
		PRINTER_12,			//RGB_DUNKELGRUEN,	//plane[3]=INTERTIDAL_AREA	12
		PRINTER_14,			//RGB_BRAUN,			//plane[4]=LAND				14
		RGB_BLAUGRAU,		//plane[5]=LAKE				6
		PRINTER_15,			//RGB_HELLBRAUN,		//plane[6]=CITY				15
		RGB_BLAUGRAU,		//plane[7]=RIVER			6
		PRINTER_11,			//RGB_VIOLETT,		//plane[8]=SEABORDERS		11
		PRINTER_15,			//RGB_HELLBRAUN,		//plane[9]=STATE/COUNTRY	15
		RGB_ROT,			//plane[10]=				13
		0,
		0,
		0,
		0,
		0,
		};

COLORREF linecol[]=
		{
		RGB_MENUBACK,	//0
		RGB_SCHWARZ,	//1
		RGB_WEISS,		//2
		RGB_MENUGRAU,	//3
		MAP_COL_SEA,	//RGB_BLAU,		//4
		RGB_GELB,		//5
		RGB(0,64,128),		//RGB_BLAUGRAU,	//6
		RGB_MENURAST,	//7
		RGB_CYANBLAU,	//8
		RGB_GRUEN,		//9
		RGB_CYAN,		//10
		RGB_VIOLETT,	//11
		RGB_DUNKELGRUEN,//12
		RGB_ROT,		//13
		MAP_COL_LAND,	//RGB_BRAUN,		//14
		MAP_COL_BORDER,	//RGB_HELLBRAUN,	//15
		PRINTER_00,
		PRINTER_01,
		PRINTER_02,
		PRINTER_03, 
		PRINTER_04, 
		PRINTER_05, 
		PRINTER_06, 
		PRINTER_07, 
		PRINTER_08, 
		PRINTER_09, 
		PRINTER_10, 
		PRINTER_11, 
		PRINTER_12, 
		PRINTER_13, 
		PRINTER_14, 
		PRINTER_15 
		};

UINT linestyle[]=
		{
		PS_INSIDEFRAME,
		PS_DASHDOTDOT,
		PS_DOT,//PS_DOT,
		PS_DOT,//PS_DASH,
		PS_DASHDOT,
		PS_DOT,
		PS_DASH,
		PS_DASHDOT
		};


/////////////////////////////////////////////////////////////////////////////////////////
//ToolTip language service
/////////////////////////////////////////////////////////////////////////////////////////

typedef struct	{
				UINT	ID;
				char	Str[94];
				}TOOLTIPS;
typedef	CArray<TOOLTIPS,TOOLTIPS&> ToolTips;

ToolTips	myToolTips;

void WINAPI LoadToolTips(char *dir) 
{
	FILE		*fi;
	char		buf[512];
	int			i,s=1;
	TOOLTIPS	t1,t2;

	myToolTips.RemoveAll();

	//MVToolTip.txt you find in Bonito MeteoCom directory
	//thats the MeteoViewer ToolTipText
	//you can make your self
	sprintf(buf,"%s\\MVToolTip.txt",dir);
	fi=fopen(buf,"r");
	if(!fi) return;
	
	//0123456
	//#65356:
	while(!feof(fi))
		{
		fgets(buf,255,fi);
		if(buf[0]!='#') continue;
		buf[6]=buf[100]=0;
		strcpy(t1.Str,&buf[7]);
		if(t1.Str[strlen(t1.Str)-1]==10) t1.Str[strlen(t1.Str)-1]=0;
		if(t1.Str[strlen(t1.Str)-1]==13) t1.Str[strlen(t1.Str)-1]=0;
		if(t1.Str[strlen(t1.Str)-1]==10) t1.Str[strlen(t1.Str)-1]=0;
		t1.ID=atoi(&buf[1]);
		myToolTips.Add(t1);
		}
	fclose(fi);

	while(s)
		{
		for(s=0,i=1; i<myToolTips.GetSize(); i++)
			{
			if(myToolTips[i].ID<myToolTips[i-1].ID)
				{
				t1=myToolTips.GetAt(i);
				t2=myToolTips.GetAt(i-1);
				myToolTips.SetAt(i,t2);
				myToolTips.SetAt(i-1,t1);
				s=1;
				}
			}
		}
}

int  WINAPI FindToolTipID(TOOLTIPTEXT *pText)
{
	int		end,top=0,bot=0,mid,oldtop=-1,oldbot=-1;

	USHORT ID =  ::GetDlgCtrlID((HWND)pText->hdr.idFrom);

	if(!ID) return FALSE;

	end=myToolTips.GetSize();
	if(!end) return FALSE;

	bot=end-1;

	if(ID==myToolTips[bot].ID) goto ende;
	if(ID>myToolTips[bot].ID) return FALSE;
		
	while(top!=bot)
		{
		mid = ((top+bot)>>1);
		if(oldtop==top && oldbot==bot) break;
		oldtop=top; oldbot=bot;
		if(ID==myToolTips[mid].ID) {bot=mid; goto ende;}
		if(ID<myToolTips[mid].ID)	//check the uppers bank
			{
			bot=mid; continue;
			}
		//check the lowers bank 

		top=mid; 
		}

	if(ID!=myToolTips[bot].ID) return FALSE;

ende:
	strcpy(pText->lpszText,myToolTips[bot].Str);
	return TRUE;
}

int  WINAPI LoadString(USHORT ID, CString &str)
{
	int		end,top=0,bot=0,mid,oldtop=-1,oldbot=-1;

	end=myToolTips.GetSize();
	if(!end) goto ende;

	bot=end-1;

	if(ID==myToolTips[bot].ID) goto ok;
	if(ID>myToolTips[bot].ID) goto ende;
		
	while(top!=bot)
		{
		mid = ((top+bot)>>1);
		if(oldtop==top && oldbot==bot) break;
		oldtop=top; oldbot=bot;
		if(ID==myToolTips[mid].ID) {bot=mid; goto ok;}
		if(ID<myToolTips[mid].ID)	//check the uppers bank
			{
			bot=mid; continue;
			}
		//check the lowers bank 

		top=mid; 
		}

	if(ID!=myToolTips[bot].ID) goto ende;;

ok:
	str=myToolTips[bot].Str;
	return TRUE;
ende:
	str.Empty();
	return FALSE;
}

void WINAPI InitButton(CWnd *wnd, int ID)
{
	CButton *b =(CButton *)wnd->GetDlgItem(ID);
	if(!b) return;

	CString str;
	if(LoadString(ID,str)) b->SetWindowText(str);
}