// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "GlobalTools.h"
#include "About.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame Bonito Implementation of linkage

CStatusBar CMainFrame::m_wndStatusBar;

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_TIMER()
	ON_COMMAND(ID_APP_ABOUT,			OnAppAbout)
	ON_COMMAND(IDM_ADD,					OnZoomADD)
	ON_COMMAND(IDM_DOWN,				OnZoomDOWN)
	ON_COMMAND(IDM_LEFT,				OnZoomLEFT)
	ON_COMMAND(IDM_SUBTRACT,			OnZoomSUB)
	ON_COMMAND(IDM_HOME,				OnZoomHOME)
	ON_COMMAND(IDM_RIGHT,				OnZoomRIGHT)
	ON_COMMAND(IDM_UP,					OnZoomUP)
	ON_COMMAND(ID_FIXPOINT,				OnSetFixZoom)
	ON_UPDATE_COMMAND_UI(ID_FIXPOINT,	OnUpdateFixZoom)
	ON_COMMAND(ID_SPEED_MINUS,			OnSpeedM)
	ON_COMMAND(ID_SPEED_RESET,			OnSpeedR)
	ON_COMMAND(ID_SPEED_PLUS,			OnSpeedP)
	ON_COMMAND(ID_DATE_PLAY,			OnPlay)
	ON_COMMAND(ID_DATE_RPLAY,			OnRPlay)
	ON_COMMAND(IDC_SET_UTC,				OnSetUtc)
	ON_COMMAND(IDC_METEOCOM,			OnMeteocom)
	ON_COMMAND(IDM_CONTACT,				OnBonitoWeb)
	ON_UPDATE_COMMAND_UI(ID_SPEED_RESET,OnUpdateSpeedR)
	ON_UPDATE_COMMAND_UI(ID_SPEED_MINUS,OnUpdateSpeedM)
	ON_UPDATE_COMMAND_UI(ID_SPEED_PLUS, OnUpdateSpeedP)
	ON_UPDATE_COMMAND_UI(ID_DATE_RPLAY, OnUpdateRPlay)
	ON_UPDATE_COMMAND_UI(ID_DATE_PLAY,	OnUpdatePlay)
	ON_UPDATE_COMMAND_UI(IDC_SET_UTC,	OnUpdateUTC)
	ON_UPDATE_COMMAND_UI(IDC_METEOCOM,	OnUpdateMeteoCom)
	ON_UPDATE_COMMAND_UI(IDM_DETAILS,	OnUpdateDetails)
	ON_BN_CLICKED(IDC_DATA,				SwitchData)
	ON_BN_CLICKED(IDC_IMAGES,			SwitchImages)
	ON_COMMAND(IDC_COPY,				OnCopyText)
	ON_COMMAND(IDC_COPY2,				OnCopyText)

	ON_WM_SIZE()
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_METEOCOM_LOGIN,LogMeIn)
	ON_MESSAGE(WM_METEOCOM_LOGOUT,LogMeOut)
	ON_MESSAGE(WM_METEOCOM_COL_CHANGE,RefreshColor)
	ON_MESSAGE(WM_METEOCOM_DAT_CHANGE,MeteoDataChanged)
	ON_MESSAGE(WM_BONITO_PICFILE,OnPicFileChanged)

END_MESSAGE_MAP()

void CMainFrame::OnBonitoWeb() 
{
		ShellExecute(NULL, NULL,"http://www.meteoserver.net/Development/overview.htm", NULL,NULL, SW_SHOWNORMAL);	
}

LRESULT CMainFrame::LogMeIn(WPARAM wParam, LPARAM lParam)
{
	myBMS_Para.MeteoComHWND=(HWND) wParam;
	m_wndTimeToolBar.Invalidate();
	SetForegroundWindow();

	return NULL; //if OK;
}

LRESULT CMainFrame::LogMeOut(WPARAM wParam, LPARAM lParam)
{
	myBMS_Para.MeteoComHWND=0;
	m_wndTimeToolBar.Invalidate();
	return NULL; //if OK;
}

LRESULT CMainFrame::RefreshColor(WPARAM wParam, LPARAM lParam)
{
	myMeteoView->SetColors();	//get and set the new color array
	myBMS_Para.refresch=-1;		//we use this as repaint flag
	myMeteoView->N_scale=-1;	//we use this as repaint flag
	myMeteoView->Invalidate();	//and then, refresh the screen
	return NULL; //if OK;
}


LRESULT CMainFrame::MeteoDataChanged(WPARAM wParam, LPARAM lParam)
{
	if(wParam!=DAT_CHANGED) return NULL;

	switch(lParam)
		{
		case	DAT_CHANGE_RXSYN:
		case	DAT_CHANGE_SYN:
		case	DAT_CHANGE_MET: DataChanged();
								break;

		case	DAT_CHANGE_FAX:
		case	DAT_CHANGE_IMG:	LoadPictureList();
								break;	
		}

	return NULL; //if OK;
}

//Note: All synop files will stand above in the list. The first meteo file will come after the last synop file.

void CMainFrame::DataChanged() 
{
	LoadAllMSDFiles();
	
	int		i,x=FirstSynopDate.stepswidth;

	// if MeteoDataSelection==1, then was Synop selected
	// FirstSynopDate.stepswidth is the count of all synop files
	// if a synop file selected, then find them in the list

	if(FirstSynopDate.stepswidth && MeteoDataSelection==1)
		{
		for(i=0; i<FirstSynopDate.stepswidth; i++)
			{
			if(ExistDates[i].validtime == NowDate.validtime) goto set;
			}
		}
	else
		{
		//no, then find them after the last synop poisition
		MeteoDataSelection=1;
		for(i=x; i<ExistDates.GetSize(); i++)
			{
			if(ExistDates[i].validtime == NowDate.validtime && !strcmp(ExistDates[i].regstr,NowDate.regstr))
				{
				if(ExistDates[i].type==2) //if MeteoPack/EmailBulletins
					{
					if(NowDate.hour != ExistDates[i].hour) continue;
					}
				MeteoDataSelection=i-x+1;
				goto set;
				}
			}
		}
	i=0; //maybe the last one was deleted
set:

	m_wndTimeToolBar.SetTimeInfo(i);
	m_wndDlgBar.m_Details.SetButtonCondition();
	myBMS_Para.refresch=-1;
	m_wndDlgBar.m_Details.Refresh();
	myBMS_Para.refresch=myMeteoView->N_TimePos=-1;
	myMeteoView->Invalidate();
}

LRESULT CMainFrame::OnPicFileChanged(WPARAM wParam, LPARAM lParam)
{
	if(wParam==PICFILE_RELOAD) LoadPictureList();
	else m_wndDlgBar.m_Images.OnFileChanged(wParam,lParam);
	return NULL; //wenn OK;
}

// App command to run the dialog
void CMainFrame::OnAppAbout()
{
	if(m_play||m_rplay) OnStop(); 
	CAbout aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame standard routines


static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_SEPARATOR,
	ID_SEPARATOR,
	ID_SEPARATOR,
	ID_SEPARATOR,
	ID_SEPARATOR,
	ID_SEPARATOR,
	ID_SEPARATOR,
	ID_SEPARATOR,
	ID_SEPARATOR
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	m_play=m_rplay=0;
	mySpeed=10;
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)	return -1;

	myMainFrm=this;
	ConnectMeteoCom(m_hWnd,BONITO_MET_SERVICE|BONITO_PIC_SERVICE); //init the directorys of the BonitoSystem
	LoadToolTips(myBMS_Para.MeteoAccessDir);
	if (!CreateStatusBar()) return(-1);
	if(m_wndTimeToolBar.Init(this) ==-1) return -1;
	if(m_wndNavToolBar.Init(this) ==-1) return -1;
	if (!m_wndDlgBar.Create(this, IDD_LEFTDLGBAR,
		CBRS_LEFT|CBRS_TOOLTIPS|CBRS_FLYBY, IDD_LEFTDLGBAR))return -1;

//	m_wndDlgBar.Init();
	m_wndDlgBar.EnableDocking(CBRS_ALIGN_LEFT);

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndTimeToolBar.EnableDocking(CBRS_ALIGN_TOP);
	m_wndNavToolBar.EnableDocking(CBRS_ALIGN_TOP);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndDlgBar);
	m_wndDlgBar.SetWindowPos(&wndTop, 0,0,0,0,SWP_NOSIZE|SWP_NOMOVE);
	DockControlBar(&m_wndTimeToolBar);
	DockControlBar(&m_wndNavToolBar);

	SwitchData();
	LoadAllMSDFiles();
	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) ) return FALSE;
	cs.style = WS_OVERLAPPED | WS_CAPTION | FWS_ADDTOTITLE
		| WS_THICKFRAME | WS_SYSMENU | WS_MINIMIZEBOX | WS_MAXIMIZEBOX | WS_MAXIMIZE;
	return TRUE;
}

BOOL CMainFrame::CreateStatusBar()
{
	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,10)) return FALSE;       // fail to create

	UINT nID, nStyle;
	int cxWidth;

		m_wndStatusBar.GetPaneInfo( 0, nID, nStyle, cxWidth);
        m_wndStatusBar.SetPaneInfo( 0, nID, SBPS_STRETCH, cxWidth-10);
		m_wndStatusBar.SetPaneInfo( 1, nID, SBPS_NORMAL, 105);	//coordinates
        m_wndStatusBar.SetPaneInfo( 2, nID, SBPS_NORMAL, 65);	//air pressure
        m_wndStatusBar.SetPaneInfo( 3, nID, SBPS_NORMAL, 60);	//air temperature
        m_wndStatusBar.SetPaneInfo( 4, nID, SBPS_NORMAL, 65);	//huminity	
	    m_wndStatusBar.SetPaneInfo( 5, nID, SBPS_NORMAL, 80);	//wind
        m_wndStatusBar.SetPaneInfo( 6, nID, SBPS_NORMAL, 60);	//cloud
        m_wndStatusBar.SetPaneInfo( 7, nID, SBPS_NORMAL, 90);	//precipitation
		m_wndStatusBar.SetPaneInfo( 8, nID, SBPS_NORMAL, 75);	//wave
		m_wndStatusBar.SetPaneInfo( 9, nID, SBPS_NORMAL, 60);	//sfc/water temp

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

void CMainFrame::OnZoomADD()	{myMeteoView->Zoom(0,0,0,0,VK_ADD);}
void CMainFrame::OnZoomDOWN()	{myMeteoView->Zoom(0,0,0,0,VK_DOWN);}
void CMainFrame::OnZoomLEFT() 	{myMeteoView->Zoom(0,0,0,0,VK_LEFT);}
void CMainFrame::OnZoomSUB()	{myMeteoView->Zoom(0,0,0,0,VK_SUBTRACT);}
void CMainFrame::OnZoomHOME()	{myMeteoView->Zoom(0,0,0,0,VK_HOME);}
void CMainFrame::OnZoomRIGHT() 	{myMeteoView->Zoom(0,0,0,0,VK_RIGHT);}
void CMainFrame::OnZoomUP()		{myMeteoView->Zoom(0,0,0,0,VK_UP);}
void CMainFrame::OnSetFixZoom()	{myMeteoView->OnSetFixZoom();}
void CMainFrame::OnUpdateFixZoom(CCmdUI* pCmdUI) {pCmdUI->SetCheck(myMeteoView->fix_zoom);}
void CMainFrame::OnUpdateDetails(CCmdUI* pCmdUI) {pCmdUI->Enable(1);}
void CMainFrame::OnMeteocom() {myMeteoView->OnStartBonitoProgram();}
void CMainFrame::OnUpdateMeteoCom(CCmdUI* pCmdUI)
{
	pCmdUI->SetCheck(::IsWindowVisible(myBMS_Para.MeteoComHWND));
}
void CMainFrame::OnSetUtc()
{
	if(m_UTC) m_UTC=0;
	else m_UTC=1;
	myMeteoView->SetTime(m_wndNavToolBar.mySlider.GetScrollPos(),1);
}

void CMainFrame::OnUpdateUTC(CCmdUI* pCmdUI) {pCmdUI->SetCheck(m_UTC);}

void CMainFrame::OnUpdateSpeedR(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(m_rplay|m_play);
}
void CMainFrame::OnUpdateSpeedM(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(m_rplay|m_play);
}
void CMainFrame::OnUpdateSpeedP(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(m_rplay|m_play);
}

void CMainFrame::OnUpdateRPlay(CCmdUI* pCmdUI)
{
	pCmdUI->SetCheck(m_rplay!=0);
}

void CMainFrame::OnUpdatePlay(CCmdUI* pCmdUI)
{
	pCmdUI->SetCheck(m_play!=0);
}

void CMainFrame::OnSpeedM() 
{
	if(m_rplay|m_play) 
		{
		if(mySpeed<100) SetSpeed(mySpeed+10);
		else SetSpeed(mySpeed+50);
		}
}

void CMainFrame::OnSpeedR() 
{
	SetSpeed(100);
	myMeteoView->SetTime(0,1);
}

void CMainFrame::OnSpeedP() 
{
	if(m_rplay|m_play) 
		{
		if(mySpeed<100) SetSpeed(mySpeed-10);
		else SetSpeed(mySpeed-50);
		}
}

void CMainFrame::OnStop() 
{
	m_rplay=0;
	KillTimer(DLGBAR_TIMER);
	m_play=0;
	myMeteoView->UpdateWindow();
}

void CMainFrame::OnPlay() 
{
	int	pos=m_wndTimeToolBar.mySlider.GetScrollPos();

	m_rplay=0;
	KillTimer(DLGBAR_TIMER);

	if(m_play) 	m_play=0;
	else
		{
		m_play=1;
		SetTimer(DLGBAR_TIMER,mySpeed,NULL); 
		}
	m_wndTimeToolBar.SetAnimatButton();
	myMeteoView->UpdateWindow();
}

void CMainFrame::OnRPlay() 
{
	m_play=0;
	KillTimer(DLGBAR_TIMER);

	if(m_rplay) m_rplay=0;
	else
		{
		m_rplay=1;
		SetTimer(DLGBAR_TIMER,mySpeed,NULL); 
		}
	m_wndTimeToolBar.SetAnimatButton();
	myMeteoView->UpdateWindow();
}

void CMainFrame::SetSpeed(int val) 
{
	mySpeed=val;
	if(mySpeed<10) mySpeed=10;
	if(mySpeed>2000) mySpeed=2000;
	if(m_rplay|m_play) SetTimer(DLGBAR_TIMER,mySpeed,NULL); 
}

void CMainFrame::OnTimer(UINT nIDEvent) 
{
	CFrameWnd::OnTimer(nIDEvent);
	if(nIDEvent!=DLGBAR_TIMER) return;

	if(m_rplay|m_play) 
		{
		if(!myMeteoView->ZoomFlag)
			{
			int	pos=m_wndTimeToolBar.mySlider.GetScrollPos();
			pos=myMeteoView->TimePos;
			if(m_rplay) pos--;
			else pos++;
			if(pos>m_wndTimeToolBar.slide_max) pos=0;
			if(pos<0) pos=m_wndTimeToolBar.slide_max;
			myMeteoView->SetTime(pos,1);
			}
		}

	else KillTimer(DLGBAR_TIMER);
}

void CMainFrame::OnSize(UINT nType, int cx, int cy) 
{
	CFrameWnd::OnSize(nType, cx, cy);
	m_wndTimeToolBar.SetSize();
	m_wndNavToolBar.SetSize();
	m_wndDlgBar.SetSize();
}

void CMainFrame::SwitchData()
{
	m_wndDlgBar.m_Details.ShowWindow(SW_SHOW);
	m_wndDlgBar.m_Images.ShowWindow(SW_HIDE);
	CButton * A=(CButton *)m_wndDlgBar.GetDlgItem(IDC_IMAGES);
	A->SetCheck(0);
	A=(CButton *)m_wndDlgBar.GetDlgItem(IDC_DATA);
	A->SetCheck(1);
}

void CMainFrame::SwitchImages()
{
	if(m_play||m_rplay) OnStop(); 
	m_wndDlgBar.m_Images.ShowWindow(SW_SHOW);
	m_wndDlgBar.m_Details.ShowWindow(SW_HIDE);
	CButton * A=(CButton *)m_wndDlgBar.GetDlgItem(IDC_IMAGES);
	A->SetCheck(1);
	A=(CButton *)m_wndDlgBar.GetDlgItem(IDC_DATA);
	A->SetCheck(0);
}

void CMainFrame::OnCopyText()
{
	myMeteoView->OnCopyText();
}