// MeteoDetailDlg.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "GlobalTools.h"
#include "MeteoDetailDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld MeteoDetailDlg 


MeteoDetailDlg::MeteoDetailDlg(CWnd* pParent /*=NULL*/)
	: CDialog(MeteoDetailDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(MeteoDetailDlg)
	//}}AFX_DATA_INIT
	m_fig_preci = 0;
	m_fig_press = 0;
	m_fig_temp = 0;
	m_fig_wtemp = 0;
	m_fig_wave = 0;
	m_fig_wind = 1;
	m_fig_snow = 0;


	m_lay_coloredwind = 1;
	m_lay_wave = 0;
	m_lay_wavedir = 0;
	m_lay_ice = 0;
	m_lay_snow = 0;
	m_lay_cloud = m_lay_cloud_conv=m_lay_cloud_bound=0;
	m_lay_preci = 0;
	m_lay_symb_preci = 0;
	m_lay_press = 1;
	m_lay_rh = 0;
	m_lay_temp = 0;
	m_lay_wtemp = 0;
	m_lay_stemp = 0;
	m_lay_wind = 0;

	m_isobar = 1;
	m_isoterm = 0;
	m_isowterm = 0;
	m_isorh = 0;

	m_grid_onoff=0;
	m_synop_onoff=0;
	m_syn_wind=0;
	m_syn_temp=0;
	m_syn_press=0;
	m_syn_clouds=0;
}


void MeteoDetailDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(MeteoDetailDlg)
	DDX_Control(pDX, IDC_FIG_PRECI,	b_fig_preci);
	DDX_Control(pDX, IDC_FIG_RH,	b_fig_rh);
	DDX_Control(pDX, IDC_FIG_PRESS,	b_fig_press);
	DDX_Control(pDX, IDC_FIG_TEMP,	b_fig_temp);
	DDX_Control(pDX, IDC_FIG_STEMP,	b_fig_stemp);
	DDX_Control(pDX, IDC_FIG_WTEMP,	b_fig_wtemp);
	DDX_Control(pDX, IDC_FIG_WIND,	b_fig_wind);
	DDX_Control(pDX, IDC_FIG_WAVE,	b_fig_wave);

	DDX_Control(pDX, IDC_LAY_WAVEDIR,b_lay_wavedir);
	DDX_Control(pDX, IDC_LAY_WAVE,	b_lay_wave);
	DDX_Control(pDX, IDC_LAY_CLOUD,	b_lay_cloud);
	DDX_Control(pDX, IDC_LAY_CL_BOUND,b_lay_cloud_bound);
	DDX_Control(pDX, IDC_LAY_CL_CONV,b_lay_cloud_conv);
	DDX_Control(pDX, IDC_LAY_ICE,	b_lay_ice);
	DDX_Control(pDX, IDC_LAY_PRECI,	b_lay_preci);
	DDX_Control(pDX, IDC_LAY_PRESS,	b_lay_press);
	DDX_Control(pDX, IDC_LAY_SYMB_PRECI, b_lay_symb_preci);
	DDX_Control(pDX, IDC_LAY_RH,	b_lay_rh);
	DDX_Control(pDX, IDC_LAY_TEMP,	b_lay_temp);
	DDX_Control(pDX, IDC_LAY_WTEMP,	b_lay_wtemp);
	DDX_Control(pDX, IDC_LAY_STEMP,	b_lay_stemp);
	DDX_Control(pDX, IDC_LAY_WIND,	b_lay_wind);
	DDX_Control(pDX, IDC_WIND_COLOR,b_lay_coloredwind);
	DDX_Control(pDX, IDC_LAY_SNOW,	b_lay_snow);
	DDX_Control(pDX, IDC_FIG_SNOW,	b_fig_snow);

	DDX_Control(pDX, IDC_ISO_BAR,	b_isobar);
	DDX_Control(pDX, IDC_ISO_TERM,	b_isoterm);
	DDX_Control(pDX, IDC_ISO_STERM,	b_isosterm);
	DDX_Control(pDX, IDC_ISO_WTERM,	b_isowterm);
	DDX_Control(pDX, IDC_ISO_RH,	b_isorh);

	DDX_Control(pDX, IDC_SYN_GRID_ONOFF,	b_grid_onoff);
	DDX_Control(pDX, IDC_SYNOP_POINTS_ON,	b_synop_onoff);
	DDX_Control(pDX, IDC_SYN_WIND,			b_syn_wind);
	DDX_Control(pDX, IDC_SYN_TEMP,			b_syn_temp);
	DDX_Control(pDX, IDC_SYN_CLOUD_PRECI,	b_syn_clouds);
	DDX_Control(pDX, IDC_SYN_PRESS,			b_syn_press);
	DDX_Control(pDX, IDC_DATA_SELECTION,	b_data_select);

	DDX_Control(pDX, IDC_SYMB_SMALL,		b_symb_sml);
	DDX_Control(pDX, IDC_SYMB_MEDIUM,		b_symb_med);
	DDX_Control(pDX, IDC_SYMB_LARGE,		b_symb_big);

	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(MeteoDetailDlg, CDialog)
	//{{AFX_MSG_MAP(MeteoDetailDlg)
ON_BN_CLICKED(IDC_LAY_PRESS,		OnLayPress)
	ON_BN_CLICKED(IDC_LAY_TEMP,		OnLayTemp)
	ON_BN_CLICKED(IDC_LAY_WIND,		OnLayWind)
	ON_BN_CLICKED(IDC_WIND_COLOR,	OnLayColoredWind)
	ON_BN_CLICKED(IDC_LAY_CLOUD,	OnLayCloud)
	ON_BN_CLICKED(IDC_LAY_CL_CONV,	OnLayCloudConv)
	ON_BN_CLICKED(IDC_LAY_CL_BOUND,	OnLayCloudBound)

	ON_BN_CLICKED(IDC_LAY_RH,		OnLayRh)
	ON_BN_CLICKED(IDC_LAY_PRECI,	OnLayPreci)
	ON_BN_CLICKED(IDC_LAY_SYMB_PRECI,OnLayPreciSybols)

	ON_BN_CLICKED(IDC_FIG_WIND,		OnFigWind)
	ON_BN_CLICKED(IDC_FIG_PRESS,	OnFigPress)
	ON_BN_CLICKED(IDC_FIG_TEMP,		OnFigTemp)
	ON_BN_CLICKED(IDC_FIG_WAVE,		OnFigWave)
	ON_BN_CLICKED(IDC_FIG_PRECI,	OnFigPreci)
	ON_BN_CLICKED(IDC_FIG_RH,		OnFigRh)

	ON_BN_CLICKED(IDC_LAY_WAVEDIR,	OnLayWaveDir)
	ON_BN_CLICKED(IDC_ISO_BAR,		OnIsoBar)
	ON_BN_CLICKED(IDC_ISO_TERM,		OnIsoTerm)
	ON_BN_CLICKED(IDC_LAY_WAVE,		OnLayWave)
	ON_BN_CLICKED(IDC_ISO_RH,		OnIsoRh)
	ON_BN_CLICKED(IDC_LAY_WTEMP,	OnLayWtemp)
	ON_BN_CLICKED(IDC_ISO_WTERM,	OnIsoWterm)
	ON_BN_CLICKED(IDC_FIG_WTEMP,	OnFigWtemp)
	ON_BN_CLICKED(IDC_ISO_STERM,	OnIsoSterm)
	ON_BN_CLICKED(IDC_FIG_STEMP,	OnFigStemp)
	ON_BN_CLICKED(IDC_LAY_STEMP,	OnLayStemp)
	ON_BN_CLICKED(IDC_LAY_ICE,		OnLayIce)
	ON_BN_CLICKED(IDC_LAY_SNOW,		OnLaySnow)
	ON_BN_CLICKED(IDC_FIG_SNOW,		OnFigSnow)

	ON_BN_CLICKED(IDC_SYN_GRID_ONOFF,	OnGridOnOff)
	ON_BN_CLICKED(IDC_SYNOP_POINTS_ON,	OnSynopON)
	ON_BN_CLICKED(IDC_SYN_WIND,			OnSynWind)
	ON_BN_CLICKED(IDC_SYN_TEMP,			OnSynTemp)
	ON_BN_CLICKED(IDC_SYN_CLOUD_PRECI,	OnSynClouds)
	ON_BN_CLICKED(IDC_SYN_PRESS,		OnSynPress)

	ON_BN_CLICKED(IDC_SYMB_SMALL,		OnSymbSmall)
	ON_BN_CLICKED(IDC_SYMB_MEDIUM,		OnSymbMedium)
	ON_BN_CLICKED(IDC_SYMB_LARGE,		OnSymbLarge)


	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten MeteoDetailDlg 
void MeteoDetailDlg::OnOK() 
{
}

void MeteoDetailDlg::OnCancel() 
{
}

BOOL MeteoDetailDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	InitButton(this,IDC_LAY_SYMB_PRECI);
	InitButton(this,IDC_LAY_PRECI);
	InitButton(this,IDC_LAY_TEMP);
	InitButton(this,IDC_LAY_WTEMP);
	InitButton(this,IDC_LAY_STEMP);
	InitButton(this,IDC_LAY_PRESS);
	InitButton(this,IDC_LAY_WIND);
	InitButton(this,IDC_WIND_COLOR);
	InitButton(this,IDC_LAY_CLOUD);
	InitButton(this,IDC_LAY_CL_BOUND);
	InitButton(this,IDC_LAY_CL_CONV);
	InitButton(this,IDC_LAY_RH);
	InitButton(this,IDC_LAY_ICE);
	InitButton(this,IDC_LAY_SNOW);
	InitButton(this,IDC_LAY_WAVEDIR);
	InitButton(this,IDC_LAY_WAVE);

	InitButton(this,IDC_LAY_BATHY);
	InitButton(this,IDC_LAY_TOPO);
	InitButton(this,IDC_LAY_CITBOR);
	InitButton(this,IDC_LAY_RIVLAK);

	InitButton(this,IDC_FIG_WIND);
	InitButton(this,IDC_FIG_PRESS);
	InitButton(this,IDC_FIG_TEMP);
	InitButton(this,IDC_FIG_STEMP);
	InitButton(this,IDC_FIG_WTEMP);
	InitButton(this,IDC_FIG_WAVE);
	InitButton(this,IDC_FIG_PRECI);
	InitButton(this,IDC_FIG_RH);
	InitButton(this,IDC_FIG_SNOW);


	InitButton(this,IDC_ISO_TERM);
	InitButton(this,IDC_ISO_STERM);
	InitButton(this,IDC_ISO_WTERM);
	InitButton(this,IDC_ISO_BAR);
	InitButton(this,IDC_ISO_RH);


	InitButton(this,IDC_SYN_GRID_ONOFF);
	InitButton(this,IDC_SYNOP_POINTS_ON);
	InitButton(this,IDC_SYN_WIND);
	InitButton(this,IDC_SYN_TEMP);
	InitButton(this,IDC_SYN_CLOUD_PRECI);
	InitButton(this,IDC_SYN_PRESS);
	InitButton(this,IDC_DATA_SELECTION);

	InitButton(this,IDC_SYMB_SMALL);
	InitButton(this,IDC_SYMB_MEDIUM);
	InitButton(this,IDC_SYMB_LARGE);

	InitButton(this,IDC_DATA_SELECTION);


	if(myBMS_Para.RadioControlExist)
		{
		b_grid_onoff.EnableWindow(TRUE);
		b_synop_onoff.EnableWindow(TRUE);
		}

	b_data_select.RefreshList(1);
	SetPosibles();
  	return TRUE;  
	              
}

void MeteoDetailDlg::Refresh()
{
	b_data_select.RefreshList();
	SetPosibles();
}

void MeteoDetailDlg::SetPosibles()
{
	
	GetFlags();
	SetDetails(); //set MenuButton IDC_DATA_SELECTION

	SetButtonCondition();
}

void MeteoDetailDlg::SetButtonCondition() 
{

	if(NowDate.validflags&BMS_PRMSL) 
		{
		b_lay_press.EnableWindow(TRUE);
		b_fig_press.EnableWindow(TRUE);
		b_isobar.EnableWindow(TRUE);
		}
	else
		{
		b_lay_press.EnableWindow(FALSE);
		b_fig_press.EnableWindow(FALSE);
		b_isobar.EnableWindow(FALSE);
		m_lay_press=m_isoterm=m_fig_press=0;
		}

	if(NowDate.validflags&BMS_TMP) 
		{
		b_lay_temp.EnableWindow(TRUE);
		b_isoterm.EnableWindow(TRUE);
		b_fig_temp.EnableWindow(TRUE);
		}
	else
		{
		b_lay_temp.EnableWindow(FALSE);
		b_isoterm.EnableWindow(FALSE);
		b_fig_temp.EnableWindow(FALSE);
		m_lay_temp=m_isorh=m_fig_temp=0;
		}

	if(NowDate.validflags&BMS_WIND) 
		{
		b_lay_wind.EnableWindow(TRUE);
		b_fig_wind.EnableWindow(TRUE);
		b_lay_coloredwind.EnableWindow(TRUE);
		}
	else
		{
		b_fig_wind.EnableWindow(FALSE);
		b_lay_coloredwind.EnableWindow(FALSE);
		b_lay_wind.EnableWindow(FALSE);
		m_lay_wind=m_fig_wind=m_lay_coloredwind=0;
		}

	if(NowDate.validflags&BMS_TCDC) 
		{
		b_lay_cloud_conv.EnableWindow(TRUE);
		}
	else
		{
		b_lay_cloud_conv.EnableWindow(FALSE);
		m_lay_cloud_conv=0;
		}

	if(NowDate.validflags&BMS_BTCDC) 
		{
		b_lay_cloud_bound.EnableWindow(TRUE);
		}
	else
		{
		b_lay_cloud_bound.EnableWindow(FALSE);
		m_lay_cloud_bound=0;
		}

	if(NowDate.validflags&(BMS_BTCDC|BMS_TCDC))
		{
		b_lay_cloud.EnableWindow(TRUE);
		}
	else
		{
		m_lay_cloud=0;
		b_lay_cloud.EnableWindow(FALSE);
		}


	if(NowDate.validflags&BMS_APCP) 
		{
		b_lay_preci.EnableWindow(TRUE);
		b_fig_preci.EnableWindow(TRUE);
		}
	else
		{
		b_lay_preci.EnableWindow(FALSE);
		b_fig_preci.EnableWindow(FALSE);
		m_lay_preci=m_fig_preci=0;
		}

	if(NowDate.validflags&BMS_RH) 
		{
		b_lay_rh.EnableWindow(TRUE);
		b_isorh.EnableWindow(TRUE);
		b_fig_rh.EnableWindow(TRUE);
		}
	else
		{
		b_lay_rh.EnableWindow(FALSE);
		b_isorh.EnableWindow(FALSE);
		b_fig_rh.EnableWindow(FALSE);
		m_lay_rh=m_isorh=m_fig_rh=0;
		}

	if(NowDate.validflags&BMS_PFLAGS) 
		{
		b_lay_symb_preci.EnableWindow(TRUE);
		b_lay_ice.EnableWindow(TRUE);
		}
	else
		{
		b_lay_symb_preci.EnableWindow(FALSE);
		b_lay_ice.EnableWindow(FALSE);
		m_lay_symb_preci=0;
		}

	if(NowDate.validflags&BMS_WEASD) 
		{
		b_lay_snow.EnableWindow(TRUE);
		b_fig_snow.EnableWindow(TRUE);
		}
	else
		{
		b_lay_snow.EnableWindow(FALSE);
		b_fig_snow.EnableWindow(FALSE);
		m_lay_snow=m_fig_snow=0;
		}

	if(NowDate.validflags&BMS_WTMP) 
		{
		b_fig_stemp.EnableWindow(TRUE);
		b_fig_wtemp.EnableWindow(TRUE);
		b_lay_wtemp.EnableWindow(TRUE);
		b_lay_stemp.EnableWindow(TRUE);
		b_isowterm.EnableWindow(TRUE);
		b_isosterm.EnableWindow(TRUE);
		}
	else
		{
		b_fig_stemp.EnableWindow(FALSE);
		b_fig_wtemp.EnableWindow(FALSE);
		b_lay_wtemp.EnableWindow(FALSE);
		b_lay_stemp.EnableWindow(FALSE);
		b_isowterm.EnableWindow(FALSE);
		b_isosterm.EnableWindow(FALSE);
		m_lay_stemp=m_isosterm=m_fig_stemp=m_lay_wtemp=m_isowterm=m_fig_wtemp=0;
		}

	if(NowDate.validflags&BMS_HTSGW) 
		{
		b_lay_wave.EnableWindow(TRUE);
		b_fig_wave.EnableWindow(TRUE);
		}
	else
		{
		b_lay_wave.EnableWindow(FALSE);
		b_fig_wave.EnableWindow(FALSE);
		m_lay_wave=m_fig_wave=0;
		}

	if(NowDate.validflags&BMS_WVDIR) 
		{
		b_lay_wavedir.EnableWindow(TRUE);
		}
	else
		{
		b_lay_wavedir.EnableWindow(FALSE);
		m_lay_wavedir=0;
		}

	if(FirstSynopDate.stepswidth && MeteoDataSelection==1)
		{
		b_grid_onoff.EnableWindow(TRUE);
		b_synop_onoff.EnableWindow(TRUE);
		b_syn_wind.EnableWindow(TRUE);
		b_syn_temp.EnableWindow(TRUE);
		b_syn_press.EnableWindow(TRUE);
		b_syn_clouds.EnableWindow(TRUE);
		}
	else
		{
		b_grid_onoff.EnableWindow(FALSE);
		b_synop_onoff.EnableWindow(FALSE);
		b_syn_wind.EnableWindow(FALSE);
		b_syn_temp.EnableWindow(FALSE);
		b_syn_press.EnableWindow(FALSE);
		b_syn_clouds.EnableWindow(FALSE);
		}
	SetSymbButton();
}
	
void MeteoDetailDlg::OnLayPreciSybols() {m_lay_symb_preci^=1; SetDetails();}
void MeteoDetailDlg::OnLayCloud() {m_lay_cloud^=1; m_lay_cloud_bound=m_lay_cloud_conv=0; SetDetails();}
void MeteoDetailDlg::OnLayCloudBound() {m_lay_cloud_bound^=1; m_lay_cloud=0; SetDetails();}
void MeteoDetailDlg::OnLayCloudConv() {m_lay_cloud_conv^=1; m_lay_cloud=0; SetDetails();}

void MeteoDetailDlg::OnLayPreci() {m_lay_preci^=1; SetDetails();}
void MeteoDetailDlg::OnLayIce() {m_lay_ice^=1; m_lay_press=m_lay_temp=m_lay_stemp=m_lay_rh=0; SetDetails();}
void MeteoDetailDlg::OnLaySnow() {m_lay_snow^=1; SetDetails();}
void MeteoDetailDlg::OnFigSnow() {m_fig_snow^=1; m_fig_preci=0; SetDetails();}


void MeteoDetailDlg::OnLayWind() 
	{
	m_lay_wind^=1;
	if(m_lay_wind) m_lay_wavedir=m_fig_wave=0; 
	if(!m_lay_wind && !m_fig_wind) m_lay_coloredwind=0;
	SetDetails();
	}
void MeteoDetailDlg::OnLayColoredWind() 
	{
	m_lay_coloredwind^=1; 
	if(m_lay_coloredwind && !m_lay_wind) m_lay_wind=1;
	if(m_lay_wind) m_lay_wavedir=m_fig_wave=0;
	SetDetails();
	}

void MeteoDetailDlg::OnLayPress() {m_lay_press^=1; m_lay_ice=m_lay_wavedir=m_fig_wave=m_lay_wave=m_lay_temp=m_lay_wtemp=m_lay_stemp=m_lay_rh=0; SetDetails();}
void MeteoDetailDlg::OnLayTemp()	{m_lay_temp^=1;  m_lay_ice=m_lay_wavedir=m_fig_wave=m_lay_wave=m_lay_press=m_lay_wtemp=m_lay_stemp=m_lay_rh=0; SetDetails();}
void MeteoDetailDlg::OnLayWtemp() {m_lay_wtemp^=1; m_lay_press=m_lay_temp=m_lay_stemp=m_lay_rh=0; SetDetails();}
void MeteoDetailDlg::OnLayStemp() {m_lay_stemp^=1; m_lay_ice=m_lay_wavedir=m_fig_wave=m_lay_wave=m_lay_press=m_lay_temp=m_lay_wtemp=m_lay_rh=0; SetDetails();}
void MeteoDetailDlg::OnLayRh()	{m_lay_rh^=1;	 m_lay_ice=m_lay_wavedir=m_fig_wave=m_lay_wave=m_lay_press=m_lay_temp=m_lay_wtemp=m_lay_stemp=0; SetDetails();}
void MeteoDetailDlg::OnLayWave()	{m_lay_wave^=1; m_lay_stemp=m_lay_press=m_lay_temp=m_lay_stemp=m_lay_rh=0; SetDetails();}
void MeteoDetailDlg::OnLayWaveDir() {m_lay_wavedir^=1; m_lay_stemp=m_lay_press=m_lay_temp=m_lay_stemp=m_lay_rh=m_lay_wind=m_lay_coloredwind=m_fig_wind=0; SetDetails();}

void MeteoDetailDlg::OnIsoBar()	{m_isobar^=1; SetDetails();}
void MeteoDetailDlg::OnIsoTerm()	{m_isoterm^=1; SetDetails();}
void MeteoDetailDlg::OnIsoRh()	{m_isorh^=1; SetDetails();}
void MeteoDetailDlg::OnIsoWterm() {m_isowterm^=1; SetDetails();}
void MeteoDetailDlg::OnIsoSterm() {m_isosterm^=1; SetDetails();}

void MeteoDetailDlg::OnFigWind()	{m_fig_wind^=1; m_fig_rh=m_fig_preci=m_fig_wave=0; SetDetails();}
void MeteoDetailDlg::OnFigPreci() {m_fig_preci^=1; m_fig_snow=m_fig_rh=m_fig_wind=m_fig_wave=0; SetDetails();}
void MeteoDetailDlg::OnFigPress() {m_fig_press^=1; m_fig_temp=m_fig_wtemp=m_fig_stemp=0; SetDetails();}
void MeteoDetailDlg::OnFigWave()	{m_fig_wave^=1; m_lay_stemp=m_lay_press=m_lay_temp=m_lay_stemp=m_lay_rh=0; m_fig_rh=m_fig_preci=m_fig_wind=0; SetDetails();}
void MeteoDetailDlg::OnFigRh()	{m_fig_rh^=1; m_fig_wave=m_fig_preci=m_fig_wind=0; SetDetails();}

void MeteoDetailDlg::OnFigTemp()	{m_fig_temp^=1; m_fig_press=m_fig_wtemp=m_fig_stemp=0; SetDetails();}
void MeteoDetailDlg::OnFigWtemp() {m_fig_wtemp^=1; m_fig_press=m_fig_temp=m_fig_stemp=0; SetDetails();}
void MeteoDetailDlg::OnFigStemp() {m_fig_stemp^=1; m_fig_press=m_fig_wtemp=m_fig_temp=0; SetDetails();}

void MeteoDetailDlg::OnGridOnOff() {m_grid_onoff^=1; SetDetails();}
void MeteoDetailDlg::OnSynopON() {m_synop_onoff^=1; SetDetails();}
void MeteoDetailDlg::OnSynWind() {m_syn_wind^=1; SetDetails();}
void MeteoDetailDlg::OnSynTemp() {m_syn_temp^=1; SetDetails();}
void MeteoDetailDlg::OnSynPress(){m_syn_press^=1; SetDetails();}
void MeteoDetailDlg::OnSynClouds(){m_syn_clouds^=1; SetDetails();}


void MeteoDetailDlg::SetDetails() 
{
	DetailFlags=SynopDetailFlags=0;

	if(m_fig_preci) DetailFlags|=FIG_PRECI;
	if(m_fig_rh)	DetailFlags|=FIG_RH;
	if(m_fig_press) DetailFlags|=FIG_PRESS;
	if(m_fig_temp)	DetailFlags|=FIG_TEMP;
	if(m_fig_wtemp) DetailFlags|=FIG_WTEMP;
	if(m_fig_stemp) DetailFlags|=FIG_STEMP;
	if(m_fig_wind)	DetailFlags|=FIG_WIND;
	if(m_fig_snow)	DetailFlags|=FIG_SNOW;
	if(m_fig_wave)	DetailFlags|=FIG_WAVE;

	if(m_lay_cloud) DetailFlags|=LAY_CLOUDS;
	if(m_lay_cloud_conv) DetailFlags|=LAY_CLOUD_CONV;
	if(m_lay_cloud_bound) DetailFlags|=LAY_CLOUD_BOUND;
	if(m_lay_ice) DetailFlags|=LAY_ICE;
	if(m_lay_snow) DetailFlags|=LAY_SNOW;
	if(m_lay_wave) DetailFlags|=LAY_WAVE;
	if(m_lay_wavedir) DetailFlags|=LAY_WAVEDIR;
	if(m_lay_preci) DetailFlags|=LAY_PRECI;
	if(m_lay_symb_preci) DetailFlags|=LAY_SYMB_PRECI;
	if(m_lay_press) DetailFlags|=LAY_PRESS;
	if(m_lay_rh) DetailFlags|=LAY_RH;
	if(m_lay_temp) DetailFlags|=LAY_TEMP;
	if(m_lay_wtemp) DetailFlags|=LAY_WTEMP;
	if(m_lay_stemp) DetailFlags|=LAY_STEMP;
	if(m_lay_wind) DetailFlags|=LAY_WIND;
	if(m_lay_coloredwind) DetailFlags|=LAY_COL_WIND;

	if(m_isobar) DetailFlags|=FIG_ISO_BAR;
	if(m_isoterm) DetailFlags|=FIG_ISO_TERM;
	if(m_isowterm) DetailFlags|=FIG_ISO_WTERM;
	if(m_isosterm) DetailFlags|=FIG_ISO_STERM;
	if(m_isorh) DetailFlags|=FIG_ISO_RH;

	if(m_grid_onoff) SynopDetailFlags|=SYNOP_GRID;
	if(m_synop_onoff) SynopDetailFlags|=SYNOP_ONOFF;
	if(m_syn_wind) SynopDetailFlags|=SYNOP_WIND;
	if(m_syn_temp) SynopDetailFlags|=SYNOP_TEMP;
	if(m_syn_press) SynopDetailFlags|=SYNOP_PRESS;
	if(m_syn_clouds) SynopDetailFlags|=SYNOP_CLOUDS;

	b_grid_onoff.SetCheck(m_grid_onoff);
	b_synop_onoff.SetCheck(m_synop_onoff);
	b_syn_wind.SetCheck(m_syn_wind);
	b_syn_temp.SetCheck(m_syn_temp);
	b_syn_press.SetCheck(m_syn_press);
	b_syn_clouds.SetCheck(m_syn_clouds);

	b_fig_preci.SetCheck(m_fig_preci);
	b_fig_rh.SetCheck(m_fig_rh);
	b_fig_press.SetCheck(m_fig_press);
	b_fig_temp.SetCheck(m_fig_temp);
	b_fig_wave.SetCheck(m_fig_wave);
	b_fig_wind.SetCheck(m_fig_wind);

	b_lay_symb_preci.SetCheck(m_lay_symb_preci);
	b_lay_cloud.SetCheck(m_lay_cloud);
	b_lay_cloud_conv.SetCheck(m_lay_cloud_conv);
	b_lay_cloud_bound.SetCheck(m_lay_cloud_bound);
	b_lay_wavedir.SetCheck(m_lay_wavedir);
	b_lay_wave.SetCheck(m_lay_wave);
	b_lay_ice.SetCheck(m_lay_ice);
	b_lay_snow.SetCheck(m_lay_snow);
	b_fig_snow.SetCheck(m_fig_snow);

	b_lay_preci.SetCheck(m_lay_preci);
	b_lay_press.SetCheck(m_lay_press);
	b_lay_rh.SetCheck(m_lay_rh);
	b_lay_temp.SetCheck(m_lay_temp);
	b_lay_wind.SetCheck(m_lay_wind);
	b_lay_coloredwind.SetCheck(m_lay_coloredwind);


	b_isobar.SetCheck(m_isobar);
	b_fig_wave.SetCheck(m_fig_wave);
	b_isorh.SetCheck(m_isorh);

	b_isoterm.SetCheck(m_isoterm);
	b_lay_wtemp.SetCheck(m_lay_wtemp);
	b_lay_stemp.SetCheck(m_lay_stemp);
	b_fig_wtemp.SetCheck(m_fig_wtemp);
	b_isowterm.SetCheck(m_isowterm);
	b_fig_stemp.SetCheck(m_fig_stemp);
	b_isosterm.SetCheck(m_isosterm);

	if(myMeteoView)	myMeteoView->Invalidate();
}

void MeteoDetailDlg::GetFlags() 
{
	if(DetailFlags&FIG_PRECI) m_fig_preci=1;
	else m_fig_preci=0;
	if(DetailFlags&FIG_RH) m_fig_rh=1;
	else m_fig_rh=0;
	if(DetailFlags&FIG_PRESS) m_fig_press=1;
	else m_fig_press=0;
	if(DetailFlags&FIG_TEMP) m_fig_temp=1;
	else m_fig_temp=0;
	if(DetailFlags&FIG_WTEMP) m_fig_wtemp=1;
	else m_fig_wtemp=0;
	if(DetailFlags&FIG_STEMP) m_fig_stemp=1;
	else m_fig_stemp=0;
	if(DetailFlags&FIG_WIND) m_fig_wind=1;
	else m_fig_wind=0;

	if((DetailFlags&LAY_CLOUDS)==LAY_CLOUDS) m_lay_cloud=1;
	else m_lay_cloud=0;
	if((DetailFlags&LAY_CLOUD_CONV)==LAY_CLOUD_CONV) m_lay_cloud_conv=1;
	else m_lay_cloud_conv=0;
	if((DetailFlags&LAY_CLOUD_BOUND)==LAY_CLOUD_BOUND) m_lay_cloud_bound=1;
	else m_lay_cloud_bound=0;

	if(DetailFlags&LAY_ICE) m_lay_ice=1;
	else m_lay_ice=0;
	if(DetailFlags&LAY_SNOW) m_lay_snow=1;
	else m_lay_snow=0;
	if(DetailFlags&FIG_SNOW) m_fig_snow=1;
	else m_fig_snow=0;
	if(DetailFlags&LAY_WAVE) m_lay_wave=1;
	else m_lay_wave=0;
	if(DetailFlags&LAY_WAVEDIR) m_lay_wavedir=1;
	else m_lay_wavedir=0;
	if(DetailFlags&LAY_PRECI) m_lay_preci=1;
	else m_lay_preci=0;
	if(DetailFlags&LAY_SYMB_PRECI) m_lay_symb_preci=1;
	else m_lay_symb_preci=0;
	if(DetailFlags&LAY_PRESS) m_lay_press=1;
	else m_lay_press=0;
	if(DetailFlags&LAY_RH) m_lay_rh=1;
	else m_lay_rh=0;
	if(DetailFlags&LAY_TEMP) m_lay_temp=1;
	else m_lay_temp=0;
	if(DetailFlags&LAY_WTEMP) m_lay_wtemp=1;
	else m_lay_wtemp=0;
	if(DetailFlags&LAY_STEMP) m_lay_stemp=1;
	else m_lay_stemp=0;
	if(DetailFlags&LAY_WIND) m_lay_wind=1;
	else m_lay_wind=0;
	if(DetailFlags&LAY_COL_WIND) m_lay_coloredwind=1;
	else m_lay_coloredwind=0;

	if(DetailFlags&FIG_ISO_BAR) m_isobar=1;
	else m_isobar=0;
	if(DetailFlags&FIG_ISO_TERM) m_isoterm=1;
	else m_isoterm=0;
	if(DetailFlags&FIG_ISO_WTERM) m_isowterm=1;
	else m_isowterm=0;
	if(DetailFlags&FIG_ISO_STERM) m_isosterm=1;
	else m_isosterm=0;

	if(DetailFlags&FIG_WAVE) m_fig_wave=1;
	else m_fig_wave=0;
	if(DetailFlags&FIG_ISO_RH) m_isorh=1;
	else m_isorh=0;

	if(SynopDetailFlags&SYNOP_GRID) m_grid_onoff=1;
	else m_grid_onoff=0;
	if(SynopDetailFlags&SYNOP_ONOFF) m_synop_onoff=1;
	else m_synop_onoff=0;
	if(SynopDetailFlags&SYNOP_WIND) m_syn_wind=1;
	else m_syn_wind=0;
	if(SynopDetailFlags&SYNOP_TEMP) m_syn_temp=1;
	else m_syn_temp=0;
	if(SynopDetailFlags&SYNOP_PRESS) m_syn_press=1;
	else m_syn_press=0;
	if(SynopDetailFlags&SYNOP_CLOUDS) m_syn_clouds=1;
	else m_syn_clouds=0;

}



void MeteoDetailDlg::OnSymbSmall()
{
	myMeteoView->SetSymbolsSize(0);	
	myMeteoView->Invalidate();
}
void MeteoDetailDlg::OnSymbMedium()
{
	myMeteoView->SetSymbolsSize(1);
	myMeteoView->Invalidate();
}
void MeteoDetailDlg::OnSymbLarge()
{
	myMeteoView->SetSymbolsSize(2);
	myMeteoView->Invalidate();
}

void MeteoDetailDlg::SetSymbButton()
{
	if(myBMS_Para.GridSize) 
		{
		b_symb_sml.SetCheck(FALSE);
		if(myBMS_Para.GridSize==1) 
			{
			b_symb_big.SetCheck(FALSE);
			b_symb_med.SetCheck(TRUE);
			}
		else
			{
			b_symb_big.SetCheck(TRUE);
			b_symb_med.SetCheck(FALSE);
			}
		}
	else
		{
		b_symb_big.SetCheck(FALSE);
		b_symb_med.SetCheck(FALSE);
		b_symb_sml.SetCheck(TRUE);
		}
}