#include "stdafx.h"
#include "GlobalTools.h"
#include "MeteoFileBox.h"
#include "MeteoView.h"


#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMeteoFileBox

CMeteoFileBox::CMeteoFileBox()
{
	flag=0; last_select=-2;
}

CMeteoFileBox::~CMeteoFileBox()
{
}

BEGIN_MESSAGE_MAP(CMeteoFileBox, CComboBox)
	//{{AFX_MSG_MAP(CMeteoFileBox)
	ON_CONTROL_REFLECT(CBN_SELCHANGE, OnSelchange)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMeteoFileBox message handlers


void CMeteoFileBox::RefreshList(int load)
{
	CTimeUTC tim,tam;
	time_t	t,u;
	CString str;
	int i,x,pos=-1;

	flag=1; //NO REDRAW
	ResetContent();

	if(load) LoadAllMSDFiles();
	x=FirstSynopDate.stepswidth;

	MeteoDataSelection=0;
	if(x)
		{
		MeteoDataSelection=1;
		tim=FirstSynopDate.validtime;
		tam=ExistDates[x-1].validtime;
		str.Format(" SYN %s - %s",tim.Format("%d.%m-%H:%M"),tam.Format("%d.%m-%H:%M"));
		AddString(str);
		SetCurrentMSDFile(x-1);
		}

	for(i=x; i<ExistDates.GetSize(); i++)
		{	
		tim=ExistDates[i].validtime;
		tam=ExistDates[i].validtime+ExistDates[i].stepswidth*3600;
		if(ExistDates[i].type==2)
			{
			str.Format("FRC %s %s+%d MeteoPack",ExistDates[i].regstr,tim.Format("%d.%b %H:%M"),ExistDates[i].hour);
			}
		else if(ExistDates[i].region<MAX_REG)
			{
			str.Format("FRC %s %s+%d - %s",ExistDates[i].regstr,tim.Format("%d.%m-%H:%M"),ExistDates[i].stepswidth,tam.Format("%d.%m-%H:%M"));
			}
		else
			{
			str.Format("%s - %s",tim.Format(" Forecast %d.%m-%H:%M"),tam.Format("%d.%m-%H:%M"));
			}
		AddString(str);
		}

	if(FirstSynopDate.stepswidth && MeteoDataSelection==1)
		{
		for(i=0; i<FirstSynopDate.stepswidth; i++)
			{
			//note: !!! the basis time have +6 hours offset NowDate.validtime
			if((ExistDates[i].validtime-21600)  == NowDate.validtime) goto set;
			}
		}
	else
		{
		MeteoDataSelection=1;
		for(i=x; i<ExistDates.GetSize(); i++)
			{
			//note: !!! the basis time have +6 hours offset to the NowDate.validtime
			u=NowDate.validtime;
			if(ExistDates[i].type==2) t=ExistDates[i].validtime;
			else t=ExistDates[i].validtime-21600;
			if(t == NowDate.validtime && !strcmp(ExistDates[i].regstr,NowDate.regstr))
				{
				if(ExistDates[i].type==2)
					{
					if(NowDate.hour != ExistDates[i].hour) continue;
					}
				MeteoDataSelection=i-x+1;
				goto set;
				}
			}
		}

	i=0;

set:
	pos=i;
	flag=0;
	Select(pos);
	if(pos==-1) myMeteoView->SetDate(-1);
	Invalidate();
}


void CMeteoFileBox::OnSelchange() 
{
	if(!flag) //NO REDRAW
		{
		myMeteoView->SetDate(GetCurSel());
		}
	flag=0;
}

void CMeteoFileBox::Select(int sel)
{
	flag=1; //NO REDRAW
	MeteoDataSelection=1+sel;
	SetCurSel(sel);
	flag=0;
}
