#ifndef BMSTOOLS
#define BMSTOOLS


#include <afxtempl.h>
#include <windowsx.h>
#include <mmsystem.h>
#include <mmreg.h>
#include <msacm.h>
#include <direct.h>
#include <vfw.h>
#include "MeteoToolsDefs.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif //_DEBUG

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#ifndef METEOSERVERTOOL_DLL
#define METEOSERVERTOOL_DLL


typedef BMSDLL_DATA&		(WINAPI *DLL_GetBSM_Para)();
typedef PictureFileList&	(WINAPI *DLL_GetPicFiles)(int);
typedef IsoLines&			(WINAPI *DLL_GetPoliLines)();
typedef Coordinates&		(WINAPI *DLL_GetCoordinates)();
typedef IsoPlane&			(WINAPI *DLL_GetIsoPlanes)();
typedef ColorMatrix&		(WINAPI *DLL_GetColorMatrix)();
typedef BMSDSynopList&		(WINAPI *DLL_GetSynopDataSet)();
typedef MSDFile&			(WINAPI *DLL_GetMSDFileList)();
typedef MSDFILE&			(WINAPI *DLL_GetCurrentMSDFile)();
typedef MSDFILE&			(WINAPI *DLL_GetFirstSynopMSDFile)();
typedef DRAW_PARA&			(WINAPI *DLL_GetDrawPara)();

#define myPicFiles(folder)	GetPicFiles(folder)
#define myBMS_Para			GetBSM_Para()
#define myPoliLines			GetPoliLines()
#define myCoordinates		GetCoordinates()
#define myIsoPlanes			GetIsoPlanes()
#define myColors(reset)		GetColorMatrix(reset)
#define mySynopList			GetSynopDataSet()
#define NowDate				GetCurrentMSDFile()
#define ExistDates			GetMSDFileList()
#define FirstSynopDate		GetFirstSynopMSDFile()	
#define myDrawPara			GetDrawPara()

typedef void	(WINAPI *DLL_ConnectMeteoCom)(HWND,int);
typedef void	(WINAPI *DLL_DisconnectMeteoCom)();
typedef BOOL	(WINAPI *DLL_GetDataOfPoint)(int,int,BMSDATA_SET*);
typedef BOOL	(WINAPI *DLL_GetSynopDataOfPoint)(int,int,BMSD_SYN*,char *);

typedef	int		(WINAPI *DLL_SetSynopField)(time_t);
typedef	BOOL	(WINAPI *DLL_LoadScreenField)(time_t,int,int,ScreenGridData &);
typedef	BOOL	(WINAPI *DLL_LoadDataField)(time_t,int,int,BMSDataList &);
typedef void	(WINAPI *DLL_LoadPictureList)();

typedef void	(WINAPI *DLL_DrawThumbFolders)(HDC,int,CRect &,int,int,int,int);

typedef void	(WINAPI *DLL_DrawSeaData)(CDC*,LPRECT,time_t,int,int,float,float,float,float);
typedef void	(WINAPI *DLL_DrawSfcData)(CDC*,LPRECT,time_t,int,int,float,float,float,float);
typedef void	(WINAPI *DLL_DrawSynData)(CDC*,LPRECT,time_t,int,int,float,float,float,float);

typedef void	(WINAPI *DLL_MovePicFile)(int,int,int);
typedef void	(WINAPI *DLL_DeletePicFile)(int,int);
typedef void	(WINAPI *DLL_RenamePicFileName)(int,int,char*);

typedef void	(WINAPI *DLL_DecodeMPfromFile)(char*);
typedef void	(WINAPI *DLL_DecodeMPfromClipBoard)(HWND);
typedef time_t	(WINAPI *DLL_LoadAllMSDFiles)();
typedef void	(WINAPI *DLL_SetCurrentMSDFile)(int);
typedef void	(WINAPI *DLL_SetGridDimension)(int,int);

extern HINSTANCE m_DllHandle;

extern DLL_ConnectMeteoCom			ConnectMeteoCom;
extern DLL_DisconnectMeteoCom		DisconnectMeteoCom;
extern DLL_GetBSM_Para				GetBSM_Para;

extern DLL_LoadPictureList			LoadPictureList;
extern DLL_GetPicFiles				GetPicFiles;
extern DLL_DrawThumbFolders			DrawThumbFolders;

extern DLL_GetColorMatrix			GetColorMatrix;
extern DLL_LoadDataField			LoadDataField;
extern DLL_LoadScreenField			LoadScreenField;
extern DLL_SetSynopField			SetSynopField;
extern DLL_GetSynopDataSet			GetSynopDataSet;

extern DLL_GetDataOfPoint			GetDataOfPoint;
extern DLL_GetSynopDataOfPoint		GetSynopDataOfPoint;
extern DLL_GetPoliLines				GetPoliLines;
extern DLL_GetCoordinates			GetCoordinates;
extern DLL_GetIsoPlanes				GetIsoPlanes;
extern DLL_MovePicFile				MovePicFile;
extern DLL_DeletePicFile			DeletePicFile;
extern DLL_RenamePicFileName		RenamePicFileName;
extern DLL_DrawSeaData				DrawSeaData;
extern DLL_DrawSfcData				DrawSfcData;
extern DLL_DrawSynData				DrawSynData;

extern DLL_DecodeMPfromFile			DecodeMPfromFile;
extern DLL_DecodeMPfromClipBoard	DecodeMPfromClipBoard;
extern DLL_GetMSDFileList			GetMSDFileList;
extern DLL_GetCurrentMSDFile		GetCurrentMSDFile;
extern DLL_GetFirstSynopMSDFile		GetFirstSynopMSDFile;
extern DLL_LoadAllMSDFiles			LoadAllMSDFiles;
extern DLL_SetCurrentMSDFile		SetCurrentMSDFile;
extern DLL_SetGridDimension			SetGridDimension;
extern DLL_GetDrawPara				GetDrawPara;

BOOL	WINAPI InstallMeteoServerTool();
void	WINAPI DeInstallMeteoServerTool();

extern char	myDIR[512];

#endif //BMSTOOLS

#endif //METEOSERVERTOOL_DLL