#include "stdafx.h"
#include "MainFrm.h"
#include "GlobalTools.h"
#include "MeteoDoc.h"
#include "MeteoView.h"
#include "MeteoTools.h"
#include "MeteoKlickDlg.h"
#include	<math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CMeteoView

IMPLEMENT_DYNCREATE(CMeteoView, CView)

BEGIN_MESSAGE_MAP(CMeteoView, CView)
	//{{AFX_MSG_MAP(CMeteoView)
	ON_WM_KEYDOWN()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_SIZE()
	ON_WM_MOUSEMOVE()
	ON_WM_ERASEBKGND()
	ON_WM_CONTEXTMENU()
	ON_WM_VSCROLL()
	ON_WM_HSCROLL()
	ON_COMMAND(ID_START_BONITOPROG, OnStartBonitoProgram)
	ON_COMMAND(IDM_ADD,		OnZoomADD)
	ON_COMMAND(IDM_DOWN,	OnZoomDOWN)
	ON_COMMAND(IDM_LEFT,	OnZoomLEFT)
	ON_COMMAND(IDM_SUBTRACT,OnZoomSUB)
	ON_COMMAND(IDM_HOME,	OnZoomHOME)
	ON_COMMAND(IDM_RIGHT,	OnZoomRIGHT)
	ON_COMMAND(IDM_UP,		OnZoomUP)
	ON_COMMAND(IDC_COPY,	OnCopyText)
	ON_COMMAND(IDC_COPY2,	OnCopyText)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMeteoView Konstruktion/Destruktion

CMeteoView::CMeteoView()
{
	NowDate.validtime=time(0);

	ObjectScale=.02;
	ZoomFlag=0;
	lmapscale=fullscale= 32.;
	lmapyoff=lmapxoff=0.; 
	min_scale=.03;
	N_TimePos=-1;
	SynopDetailFlags=0;
	ViewRect.right=ViewRect.top=ViewRect.bottom=ViewRect.left=-1;
	fix_zoom=TimePos=0;
	lastcontextpoint.x=lastcontextpoint.y=-1;
}

CMeteoView::~CMeteoView()
{
}



BOOL CMeteoView::PreCreateWindow(CREATESTRUCT& cs)
{
	cs.style|=WS_HSCROLL|WS_VSCROLL;
	return CView::PreCreateWindow(cs);
}

void CMeteoView::OnInitialUpdate() 
{
	CView::OnInitialUpdate();
	
	myMeteoView=this;


	SetSymbolsSize(myBMS_Para.GridSize);


	DetailFlags=GetMyProfileInt("MAP","DetailFlags",FIG_ISO_BAR|LAY_PRECI|LAY_TEMP|LAY_CLOUDS);
	SynopDetailFlags=GetMyProfileInt("MAP","SynopDetailFlags",SYNOP_WIND|SYNOP_TEMP|SYNOP_PRESS|SYNOP_CLOUDS);

	printerflag=ZoomFlag=0;

	CDC* pDC=GetDC();
	pDC->SetMapMode(MM_TEXT);
	GetClientRect(MeteoRect);
	ViewRect=MeteoRect;
	sizeTotal=ViewRect.Size();

//Europa
	lmapxoff=MeteoCfg.lmapxoff;
	lmapyoff=MeteoCfg.lmapyoff;
	lmapscale=MeteoCfg.screenscale;

	lmapxoff=GetMyProfileDouble("MAP","lmapxoff",lmapxoff);
	lmapyoff=GetMyProfileDouble("MAP","lmapyoff",lmapyoff);
	lmapscale=GetMyProfileDouble("MAP","lmapscale",lmapscale);
	fullscale=GetMyProfileDouble("MAP","fullscale",fullscale);

	fix_lmapxoff=GetMyProfileDouble("MAP","fix_lmapxoff",fix_lmapxoff);
	fix_lmapyoff=GetMyProfileDouble("MAP","fix_lmapyoff",fix_lmapyoff);
	fix_zoom=GetMyProfileInt("MAP","fix_zoom",0);
	m_UTC=GetMyProfileInt("MAP","UTC_LOCAL",0);

	double w;
	for(int z=0; z<256; z++)
		{
		knots[z]=(int)((double)z*.48595); //0.25 * 1.9438 = .48595
		w=(double)z*.25;
		beaufort[z]=0; 
		if(w != 0.)
			{
			if(w >= 57.0) beaufort[z] = 17;
			else if(w >= 51.0) beaufort[z] = 16;
			else if(w >= 46.2) beaufort[z] = 15; 
			else if(w >= 41.5) beaufort[z] = 14;
			else if(w >= 37.0) beaufort[z] = 13; 
			else if(w >= 32.7) beaufort[z] = 12;
			else if(w >= 28.5) beaufort[z] = 11; 
			else if(w >= 24.5) beaufort[z] = 10;
			else if(w >= 20.8) beaufort[z] = 9; 
			else if(w >= 17.2) beaufort[z] = 8;
			else if(w >= 13.9) beaufort[z] = 7; 
			else if(w >= 10.8) beaufort[z] = 6;
			else if(w >= 8.0) beaufort[z] = 5; 
			else if(w >= 5.5) beaufort[z] = 4;
			else if(w >= 3.4) beaufort[z] = 3; 
			else if(w >= 1.6) beaufort[z] = 2;
			else if(w >= 0.3) beaufort[z] = 1;
			}
		} 

	SetColors();

	SetMeteoCoordinates(); 

	myMainFrm->DataChanged();
}

void CMeteoView::SetColors()
{
	ColorMatrix& myColors=GetColorMatrix();

	//set plane colors
	planecol[0]=planecol[1]=planecol[2]=planecol[5]=linecol[4]=PAL_COL_SEA;
	planecol[3]=PAL_COL_TIDE;
	planecol[4]=linecol[14]=PAL_COL_LAND;
	planecol[6]=linecol[15]=PAL_COL_BORDER;
	planecol[7]=PAL_COL_RIVER;
	planecol[9]=PAL_COL_COUNTRY;
	myPAL_P_FRAME =PAL_P_FRAME;

}

/////////////////////////////////////////////////////////////////////////////
// CMeteoView Zeichnen

void CMeteoView::OnDraw(CDC* pDC)
{
CDC			dc;
	CDC*		pDrawDC;
	CBrush		brush;
	CBitmap		bitmap;
	CBitmap*	pOldBitmap;
	CPen		pen;
	CSize		size;


	size=ViewRect.Size();
	pDrawDC=pDC;

	if (!pDC->IsPrinting())
		{
		if (dc.CreateCompatibleDC(pDC))
			{
			if (bitmap.CreateCompatibleBitmap(pDC, size.cx, size.cy))
				{
				//OnPrepareDC(&dc, NULL);
				pDrawDC = &dc;
				pOldBitmap = dc.SelectObject(&bitmap);
				}
			}
		}

	m_logbrush.lbColor = m_logpen.lopnColor = linecol[4];
	m_logbrush.lbStyle = BS_SOLID;
	m_logbrush.lbHatch = HS_HORIZONTAL;	
	brush.CreateBrushIndirect(&m_logbrush);

	m_logpen.lopnStyle = PS_INSIDEFRAME;
	m_logpen.lopnWidth.x = m_logpen.lopnWidth.y = 1;

	pen.CreatePenIndirect(&m_logpen);
	CPen*   pOldPen   = (CPen*)  pDrawDC->SelectObject(&pen);
	CFont*  pOldFont  = (CFont*) pDrawDC->SelectObject(&myFond);
	CBrush*	pOldBrush = (CBrush*)pDrawDC->SelectObject(&brush);
	int		pOldROP2  = pDrawDC->GetROP2();

	pDrawDC->FillRect(ViewRect, &brush);
	DrawData(pDrawDC);

	pDrawDC->SetROP2(pOldROP2);
	pDrawDC->SelectObject(pOldBrush);
	pDrawDC->SelectObject(pOldFont);
	pDrawDC->SelectObject(pOldPen);

	if (pDrawDC != pDC)
		{
		pDC->BitBlt(ViewRect.left,ViewRect.top,size.cx,size.cy,&dc, 0, 0, SRCCOPY);
		dc.SelectObject(pOldBitmap);
		}	
}

/*------------------------------------*
 * Draw DataPlane of seleceltetd date *
 *------------------------------------*/
void CMeteoView::DrawData(CDC* pDC)
{	
	int hour=TimePos;

	if(!NowDate.validtime) {PlottChart(pDC); return;} 

	//if change then will become savemap=-1
	N_scale=lmapscale;
	N_yoff=lmapyoff;
	N_xoff=lmapxoff;


	//for synop: if hour=-1, then get synop data of current selected date
	if(FirstSynopDate.stepswidth && MeteoDataSelection==1) hour=-1; 
	else if(NowDate.type==2) hour=-NowDate.hour; 

///////////////////////////////////
//using of normal MeteoTools.dll

	if(NowDate.validflags)
		{
		DrawSeaData(pDC,ViewRect,NowDate.validtime,hour,DetailFlags,(float)lmapscale,(float)lmapscale,(float)lmapxoff,(float)lmapyoff);
		PlottChart(pDC);
		DrawSfcData(pDC,ViewRect,NowDate.validtime,hour,DetailFlags,(float)lmapscale,(float)lmapscale,(float)lmapxoff,(float)lmapyoff);
		if(DetailFlags&(LAY_PRESS|LAY_TEMP|LAY_RH|LAY_WTEMP|LAY_STEMP|LAY_CLOUDS|LAY_CLOUD_BOUND|LAY_CLOUD_CONV|LAY_PRECI))
		   PlottWorldBorder(pDC);
		if(hour==-1 && (SynopDetailFlags & SYNOP_ONOFF)) 
			{
			DrawSynData(pDC, ViewRect,NowDate.validtime,hour,SynopDetailFlags,(float)lmapscale,(float)lmapscale,(float)lmapxoff,(float)lmapyoff);
			}
		}
	else PlottChart(pDC);  //if no data 





 /*
 //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

 //          if you want it complex

 //    here are the DrawingTools of the DLL
 
//////////////////////////////////////////////////////////


///////////////////////////////////
//use the class DrawingTools.cpp

	myDrawTool.DrawSeaData(pDC,ViewRect,NowDate.validtime,hour,DetailFlags,(float)lmapscale,(float)lmapscale,(float)lmapxoff,(float)lmapyoff);
	PlottChart(pDC);
	myDrawTool.DrawSfcData(pDC,ViewRect,NowDate.validtime,hour,DetailFlags,(float)lmapscale,(float)lmapscale,(float)lmapxoff,(float)lmapyoff);
	if(DetailFlags&(LAY_PRESS|LAY_TEMP|LAY_RH|LAY_WTEMP|LAY_STEMP|LAY_CLOUDS|LAY_CLOUD_BOUND|LAY_CLOUD_CONV|LAY_PRECI))
		   PlottWorldBorder(pDC);
	if(hour==-1 && (SynopDetailFlags & SYNOP_ONOFF)) 
		{
		myDrawTool.DrawSynData(pDC, ViewRect,NowDate.validtime,hour,SynopDetailFlags,(float)lmapscale,(float)lmapscale,(float)lmapxoff,(float)lmapyoff);
		}

*/
}



void CMeteoView::PlotOjects(CDC* pDC, int obj)
{

	OBJFile.Seek(sizeof(struct BOYHeader)+(obj*sizeof(struct BOYObjectPointer)),CFile::begin);
	OBJFile.Read(&OBJ_PTR,sizeof(struct BOYObjectPointer));

	for(int i=0; i<OBJ_PTR.ObjectCount; i++)
		{
		OBJFile.Seek(OBJ_PTR.ObjectSeek+(i*sizeof(struct BOYObject)),CFile::begin);
		OBJFile.Read(&OBJ_OBJ,sizeof(struct BOYObject));
		PlottObjektLines(pDC);
		}
}

void CMeteoView::PlottObjektLines(CDC* pDC)
{
	CBrush  Brush;
	CPen    Pen;
	CPen*	pOldPen;
	CBrush*  pOldBrush;
	int		i;
	COLORREF	BorderColor,FillColor;
	pDC->SetBkMode(TRANSPARENT);
	m_logpen.lopnStyle = PS_INSIDEFRAME;
	m_logpen.lopnWidth.x = m_logpen.lopnWidth.y = 1; 
	m_logbrush.lbStyle = BS_SOLID;
	m_logbrush.lbHatch = HS_HORIZONTAL;
	

	BorderColor=linecol[OBJ_OBJ.Color>>4];
	FillColor=linecol[OBJ_OBJ.Color&15];

	if(OBJ_OBJ.Type & BORDER || OBJ_OBJ.Type&POLYLINE)
			{
			if(OBJ_OBJ.Type&POLYLINE)m_logpen.lopnColor=FillColor;
			else m_logpen.lopnColor=BorderColor;
			if (!Pen.CreatePenIndirect(&m_logpen)) return;
			pOldPen=pDC->SelectObject(&Pen);
			}
	else pOldPen=(CPen*)pDC->SelectStockObject(NULL_PEN);

	if(OBJ_OBJ.Type & FILLED)
			{
			m_logbrush.lbColor=FillColor;
			if (!Brush.CreateBrushIndirect(&m_logbrush)) return;
			pOldBrush=pDC->SelectObject(&Brush);
			}
	else pOldBrush=(CBrush*)pDC->SelectStockObject(NULL_BRUSH);

	OBJFile.Seek(OBJ_OBJ.PointSeek,CFile::begin);
	OBJFile.Read(SPointIbuf,sizeof(struct LinePoint)*OBJ_OBJ.PointCount);
	
	for (i=0; i<OBJ_OBJ.PointCount; i++)
		{
		PointOBuf[i].x=ObjectOffsetX+(int)((double)((double)SPointIbuf[i].x * ObjectScale));
		PointOBuf[i].y=ObjectOffsetY+(int)((double)((double)SPointIbuf[i].y * ObjectScale));
		}
	
	switch (OBJ_OBJ.Type & 15)
		{
		case	POLYLINE:	pDC->Polyline(&PointOBuf[0],OBJ_OBJ.PointCount);
							break;
		case	 POLYGON:	pDC->Polygon(&PointOBuf[0],OBJ_OBJ.PointCount);
							break;
		case	 ELLIPSE:	pDC->Ellipse(PointOBuf[0].x,PointOBuf[0].y,PointOBuf[1].x,PointOBuf[1].y);
							break;
		}

	pDC->SelectObject(pOldPen);
	pDC->SelectObject(pOldBrush);
}

int CMeteoView::PlottChart(CDC* pDC)
{
	struct CHART_HDR	hdr;	
	int					ret=0;
	char				chartfile[512];

	sprintf(chartfile,"%s\\CHARTDATA\\WORLD.HDR",myBMS_Para.MeteoAccessDir);
	if(!lh.Open(chartfile,CFile::modeRead|CFile::typeBinary, &le)) return(-1);
	lh.Read(&hdr,sizeof(struct CHART_HDR));
	lh.Close();

	sprintf(chartfile,"%s\\CHARTDATA\\WORLD.LIN",myBMS_Para.MeteoAccessDir);
	if(!lh.Open(chartfile,CFile::modeRead|CFile::typeBinary, &le)) return(-1);
	sprintf(chartfile,"%s\\CHARTDATA\\WORLD.WPN",myBMS_Para.MeteoAccessDir);
	if(!wh.Open(chartfile,CFile::modeRead|CFile::typeBinary, &we))
		{
		lh.Abort();
		return(-1);
		}

	if(hdr.seek_window[3]>=0)  //Tides
		{
		wh.Seek(hdr.seek_window[3],CFile::begin);
		ret=Filplot_chart_vec(pDC, hdr.seek_window[3],3);
		if(ret) goto end;
		}

	if(hdr.seek_window[4]>=0)  //land layers
		{
		wh.Seek(hdr.seek_window[4],CFile::begin);
		ret=Filplot_chart_vec(pDC, hdr.seek_window[4],4);
		if(ret) goto end;
		}

	if(hdr.seek_window[5]>=0) //lakes
		{
		wh.Seek(hdr.seek_window[5],CFile::begin);
		ret=Filplot_chart_vec(pDC, hdr.seek_window[5],5);
		if(ret) goto end;
		}

	if(hdr.seek_window[7]>=0)	//rivers
		{
		wh.Seek(hdr.seek_window[7],CFile::begin);
		ret=Filplot_chart_vec(pDC, hdr.seek_window[7],7);
		}

	if(hdr.seek_window[9]>=0)	//borders
		{
		wh.Seek(hdr.seek_window[9],CFile::begin);
		ret=Filplot_chart_vec(pDC, hdr.seek_window[9],9);
		}

	
end:
	lh.Close();
	wh.Close();
	return(0);
}
int CMeteoView::Filplot_chart_vec(CDC* pDC,long seek_window,int plane) 
{
	struct POINT_WIN	lwin;
	int					ret=0,i,weite;
	long				x,y,xs,xe,ys,ye;

	pDC->SetBkMode(TRANSPARENT);

	for(int a=0;;a++)
		{
		wh.Read(&lwin,sizeof(struct POINT_WIN));
		if(!lwin.len) break;
		if( lwin.ymax < cur_chart_window.ymin) continue;
		if((lwin.xmax < cur_chart_window.xmin)
		||(lwin.xmin > cur_chart_window.xmax)) continue;
		if( lwin.ymin > cur_chart_window.ymax) break;
		xs=(long)((double)(((double)lwin.xmin/1000. + lmapxoff)/lmapscale))+swh;
		ys=(long)((double)(((double)lwin.ymin/1000. + lmapyoff)/lmapscale))+shh;
		xe=(long)((double)(((double)lwin.xmax/1000. + lmapxoff)/lmapscale))+swh;
		ye=(long)((double)(((double)lwin.ymax/1000. + lmapyoff)/lmapscale))+shh;
		if (xe>xs)	x=xe-xs;
		else		x=xs-xe;
		if (ye>ys)	y=ye-ys;
		else		y=ys-ye;
		if(y<4 && x<4) continue;

		if(lwin.len>1024) lwin.len=1024;
		lh.Seek(lwin.coor_file_seekpos,CFile::begin);
		lh.Read(&PointIBuf[0],sizeof(struct POINT_NEWLINE)*lwin.len);
		for (i=0, lwin.len-1; i<lwin.len; i++)
			{
			PointOBuf[i].x=(int)((double)(((double)PointIBuf[i].lon/1000. + lmapxoff)/lmapscale))+swh;
			PointOBuf[i].y=(int)((double)(((double)PointIBuf[i].lat/1000. + lmapyoff)/lmapscale))+shh;
			if(PointOBuf[i].x>ClipMax)PointOBuf[i].x=ClipMax;
			if(PointOBuf[i].x<-ClipMax)PointOBuf[i].x=-ClipMax;
			if(PointOBuf[i].y>ClipMax)PointOBuf[i].y=ClipMax;
			if(PointOBuf[i].y<-ClipMax)PointOBuf[i].y=-ClipMax;
			}

		m_logpen.lopnStyle = linestyle[((lwin.info_flag_1>>4)&3)];
		if(plane>5 && plane != 7) 
			{
			m_logbrush.lbColor = m_logpen.lopnColor = linecol[(lwin.info_flag_1&0x0F)+printerflag];
			pDC->SetTextColor(linecol[(lwin.info_flag_1&0x0F)+printerflag]);
			}
		else 
			{
			m_logpen.lopnColor = planecol[plane+printerflag];
			m_logbrush.lbColor = planecol[plane+printerflag];
			pDC->SetTextColor(planecol[plane+printerflag]);

			}
		weite = 1; //if((lwin.info_flag_1>>4)>4) weite=2;
		m_logpen.lopnWidth.x = m_logpen.lopnWidth.y = weite; 
		m_logbrush.lbStyle = BS_SOLID;
		m_logbrush.lbHatch = HS_HORIZONTAL;	
	
    	if (lwin.info_flag_2 & LINE_CODE_FILL) 
			{
			if(plane>5)PlotPolygon(pDC,lwin.len,lwin.info_flag_2);
			else PlotPolygon(pDC,lwin.len,0);
			}
		else
			{
			if(plane<6) m_logpen.lopnStyle = PS_INSIDEFRAME;
			PlotLine(pDC,lwin.len);
			}
		}

	return ret;
}
void CMeteoView::PlotLine(CDC* pDC,int len)
{
	CPen Pen;
	if (!Pen.CreatePenIndirect(&m_logpen))
		return;
	CPen* pOldPen=pDC->SelectObject(&Pen);
	pDC->Polyline(&PointOBuf[0],len);
	pDC->SelectObject(pOldPen);
}

void CMeteoView::PlotPolygon(CDC* pDC,int len,int style)
{
	CBrush	Brush;
	CPen*	pOldPen;
	CPen	Pen;
	


	if ((style & LINE_CODE_RAST) || (style & LINE_CODE_LINE))
		{
		//if(style & LINE_CODE_LINE){if(!Brush.CreatePatternBrush(&m_fine_raster)) return;}
		//else {if(!Brush.CreatePatternBrush(&m_grob_raster)) return;}
		if(style & LINE_CODE_LINE) m_logbrush.lbHatch = HS_DIAGCROSS;
		else m_logbrush.lbHatch = HS_FDIAGONAL;
		m_logbrush.lbStyle = BS_HATCHED; 
		
		pDC->SetBkMode(TRANSPARENT);
		//pDC->SetBkColor(~m_logbrush.lbColor);
		//pDC->SetTextColor(m_logbrush.lbColor);
		//pDC->SetROP2(R2_MASKPEN);R2_XORPEN
		}
	else
		{
		//if (!Brush.CreateBrushIndirect(&m_logbrush))return;
		m_logbrush.lbStyle = BS_SOLID; 
		}

	if (!Brush.CreateBrushIndirect(&m_logbrush))return;
	CBrush* pOldBrush=pDC->SelectObject(&Brush);
	if (style & LINE_CODE_BORDER)
		{
		if (!Pen.CreatePenIndirect(&m_logpen)) return;
		pOldPen=pDC->SelectObject(&Pen);
		}
	else 
		{
		pOldPen=(CPen*)pDC->SelectStockObject(NULL_PEN);
		}

	pDC->Polygon(&PointOBuf[0],len);
	pDC->SelectObject(pOldBrush);
	pDC->SelectObject(pOldPen);
}	 
void CMeteoView::OnZoomADD() {Zoom(0,0,0,0,VK_ADD);}
void CMeteoView::OnZoomDOWN() {Zoom(0,0,0,0,VK_DOWN);}
void CMeteoView::OnZoomLEFT() {Zoom(0,0,0,0,VK_LEFT);}
void CMeteoView::OnZoomSUB() {Zoom(0,0,0,0,VK_SUBTRACT);}
void CMeteoView::OnZoomHOME() {Zoom(0,0,0,0,VK_HOME);}
void CMeteoView::OnZoomRIGHT() {Zoom(0,0,0,0,VK_RIGHT);}
void CMeteoView::OnZoomUP() {Zoom(0,0,0,0,VK_UP);}

void CMeteoView::Zoom(int xmin, int xmax, int ymin, int ymax, UINT key)
{
	double				fx;

	if (!key)
		{
		lmapxoff +=(double)((double)swh - (double)((double)xmin + (double)(xmax - xmin) / 2.)) * lmapscale;
		lmapyoff +=(double)((double)shh - (double)((double)ymin + (double)(ymax - ymin) / 2.)) * lmapscale;
		lmapscale =((double)(xmax - xmin) * lmapscale) / X_ZoomFac;
		}
	else
		{
		 fx=20.; //if(key & ZOOM_SHIFT) fx=10.;
		 switch(key)
			{
			case    VK_HOME:	lmapscale=fullscale; lmapyoff=lmapxoff=0;
								break;
			case   VK_ADD:
			case	'+':
				     //if() lmapscale /=1.1; ->else
				     lmapscale /=2;
				     break;
			case   VK_SUBTRACT:
			case	'-':
				     //if(shift & LSHIFT || shift & RSHIFT) lmapscale *=1.1;
				     lmapscale *=2;
				     break;

			case   VK_UP:
				     lmapyoff +=((double)((double)((Y_ZoomFac)/(fx*2)) * lmapscale));
				     break;
			case   VK_DOWN:
				     lmapyoff -=((double)((double)((Y_ZoomFac)/(fx*2)) * lmapscale));
				     break;
			case   VK_LEFT:
				     lmapxoff +=((double)((double)(X_ZoomFac/(fx*2)) * lmapscale));
				     break;
			case   VK_RIGHT:
				     lmapxoff -=((double)((double)(X_ZoomFac/(fx*2)) * lmapscale));
				     break;
			default: return;						
			}
		}
	chkscale(); 
	}
void CMeteoView::chkscale(void)
	{
	double			xs,ys;

	if(lmapscale >= fullscale)
		{
		lmapxoff = lmapyoff = 0.;
		lmapscale = fullscale;
		xs=(X_ZoomFac/2.)*lmapscale;
		ys=(Y_ZoomFac/2.)*lmapscale;
		goto ex;
		}
	if(lmapscale < min_scale)
		{
		//piep(FEHLER);
		lmapscale = min_scale;
		}

	xs=(X_ZoomFac/2.)*lmapscale;
	ys=(Y_ZoomFac/2.)*lmapscale;
	if (lmapxoff-xs < -10800.)
		{
		lmapxoff=-10800.+ xs;
		}
	if (lmapxoff+xs > 10800.)
		{
		lmapxoff= 10800.-xs;
		}
	if (lmapyoff-ys < -5400.)
		{
		lmapyoff=-5400.+ys;
		}
	if (lmapyoff+ys > 5400.)
		{
		lmapyoff= 5400.-ys;
		}
ex:
	cur_chart_window.xmin=(long)((double)( (-lmapxoff-xs)*1000.) );
	cur_chart_window.xmax=(long)((double)( (-lmapxoff+xs)*1000.) );
	cur_chart_window.ymin=(long)((double)( (-lmapyoff-ys)*1000.) );
	cur_chart_window.ymax=(long)((double)( (-lmapyoff+ys)*1000.) );
	Screen_ymin=(short)(cur_chart_window.ymin/1000L);
	Screen_xmin=(short)(cur_chart_window.xmin/1000L);
	Screen_ymax=(short)(cur_chart_window.ymax/1000L);
	Screen_xmax=(short)(cur_chart_window.xmax/1000L);
		
	if(myMainFrm->m_wndNavToolBar.m_hWnd) myMainFrm->m_wndNavToolBar.SetPos();
	MeteoCfg.screenscale=lmapscale;
	MeteoCfg.lmapxoff=lmapxoff; 
	MeteoCfg.lmapyoff=lmapyoff;
	SetMyScrollPos(); 
	Invalidate(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// CMeteoView Diagnose

#ifdef _DEBUG
void CMeteoView::AssertValid() const
{
	CView::AssertValid();
}

void CMeteoView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMeteoView Nachrichten-Handler

void CMeteoView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: Code fr die Behandlungsroutine fr Nachrichten hier einfgen und/oder Standard aufrufen
	Zoom(0,0,0,0,nChar);
	CView::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CMeteoView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	CClientDC dc(this);
	CRect rect(point.x, point.y, point.x, point.y);
	rect.NormalizeRect();
	dc.DrawFocusRect(rect);
	c_down = point;
	c_last = point;
	m_mouse_Cwnd=SetCapture();
	ZoomFlag=1;	
	CView::OnLButtonDown(nFlags, point);
}

void CMeteoView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	if(ZoomFlag)
		{
		CClientDC dc(this);
		CRect rect(c_down.x, c_down.y, c_last.x, c_last.y);
		rect.NormalizeRect();
		dc.DrawFocusRect(rect);
		ZoomFlag=0;
		m_TopLeftZoom=rect.TopLeft();
		m_BotRightZoom=rect.BottomRight();
		ReleaseCapture();
		if(!((m_BotRightZoom.x-m_TopLeftZoom.x)<10 || (m_BotRightZoom.y-m_TopLeftZoom.y)<10))
			{
			Zoom(m_TopLeftZoom.x,m_BotRightZoom.x,m_TopLeftZoom.y,m_BotRightZoom.y,0);
			}
		else OnShowStation(point.x,point.y);
		}	
	else ZoomFlag=0;
	CView::OnLButtonUp(nFlags, point);
}

void CMeteoView::OnMouseMove(UINT nFlags, CPoint point) 
{
	
	if(ZoomFlag)
	{
	//point.x=(point.x/SYMBOLGRID)*SYMBOLGRID;
	//point.y=(point.y/SYMBOLGRID)*SYMBOLGRID;

	int x=c_down.x-point.x; 
	int y=c_down.y-point.y;


//	x=(x/SYMBOLGRID)*SYMBOLGRID;
//	y=(y/SYMBOLGRID)*SYMBOLGRID;


	if(y<0)
		{
		if(x<0)point.y=c_down.y-(sizeTotal.cy*x/sizeTotal.cx);
		else point.y=c_down.y+(sizeTotal.cy*x/sizeTotal.cx);
		}
	else
		{
		if(x>=0)point.y=c_down.y-(sizeTotal.cy*x/sizeTotal.cx);
		else point.y=c_down.y+(sizeTotal.cy*x/sizeTotal.cx);
		}

	CClientDC dc(this);
	CRect rect(c_down.x, c_down.y, c_last.x, c_last.y);
	rect.NormalizeRect();
	dc.DrawFocusRect(rect);
	rect.SetRect(c_down.x, c_down.y, point.x, point.y);
	rect.NormalizeRect();
	dc.DrawFocusRect(rect);
	c_last = point;
	
	}
	else
		{
		ZoomFlag=0;	
		SetStatusText(point.x, point.y);	
		}

	CView::OnMouseMove(nFlags, point);
}


void CMeteoView::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);
	if(myMeteoView)
		{
		GetClientRect(MeteoRect);
		ViewRect=MeteoRect;
		SetMeteoCoordinates();
		SetMyScrollPos(); 
		if(myMainFrm->m_wndNavToolBar.m_hWnd) myMainFrm->m_wndNavToolBar.SetSize();
		}
}


void CMeteoView::SetMyScrollPos() 
{
	double s=fullscale/lmapscale;
	int h= (int)(21600./s);
	int v= (int)(10800./s);
	

	int x=(int)( (10800.-(double)sizeTotal.cx*lmapscale/2)/s);
	int y=(int)( (5400.-(double)sizeTotal.cy*lmapscale/2)/s);

	SetScrollRange(SB_HORZ,-x,x);
	SetScrollRange(SB_VERT,-y,y);
	if(h==21600) EnableScrollBarCtrl(SB_HORZ,FALSE);
	else EnableScrollBarCtrl(SB_HORZ,TRUE);
	if(v==10800) EnableScrollBarCtrl(SB_VERT,FALSE);
	else EnableScrollBarCtrl(SB_VERT,TRUE);

	SetScrollPos(SB_HORZ,-(int)(lmapxoff/s),TRUE );
	SetScrollPos(SB_VERT,-(int)(lmapyoff/s),TRUE );
}

void CMeteoView::SetMeteoCoordinates() 
{

	CSize size = sizeTotal=ViewRect.Size();
	if(printerflag)
		{
		size.cx=sizeTotal.cx+ViewRect_X*2;
		size.cy=sizeTotal.cy+ViewRect_Y*2;
		swh = size.cx*2;
		shh = size.cy*2;
		}
	else
		{
		swh = size.cx*8;
		shh = size.cy*8;
		}
	if((size.cx+swh) > (size.cy+shh)) ClipMax=size.cx+swh;
	else ClipMax=size.cy+shh;

	swh = size.cx / 2;
	shh = size.cy / 2;
	double oldscale = fullscale/lmapscale;
	fullscale= 21600. / (double)size.cx;
	lmapscale=fullscale/oldscale;
	X_ZoomFac=double(size.cx);
	Y_ZoomFac=double(size.cy);
	if(min_scale==.03) chkscale(); 
}


void CMeteoView::SetStatusText(int cx, int cy)
{
	char		buf[256];
    int			x,y,lo,la;
    char		c1,c2;
	double		lon,lat;
	BMSDATA_SET klickSet; 


	lon= (lmapxoff + ((double)(swh - cx) * lmapscale));
	lat= (lmapyoff + ((double)(shh - cy) * lmapscale));
	lo=(int)-lon;
	la=(int)-lat;

	if(lat>5400. || lat <-5400.)  
		{
		CMainFrame::m_wndStatusBar.SetPaneText(1,"");
setnull:
		CMainFrame::m_wndStatusBar.SetPaneText(0,"");
		CMainFrame::m_wndStatusBar.SetPaneText(2,"");
		CMainFrame::m_wndStatusBar.SetPaneText(3,"");
		CMainFrame::m_wndStatusBar.SetPaneText(4,"");
		CMainFrame::m_wndStatusBar.SetPaneText(5,"");
		CMainFrame::m_wndStatusBar.SetPaneText(6,"");
		CMainFrame::m_wndStatusBar.SetPaneText(7,"");
		CMainFrame::m_wndStatusBar.SetPaneText(8,"");
		CMainFrame::m_wndStatusBar.SetPaneText(9,"");
		return;
		}

	if(lat < 0) {c1 = 'S'; lat = -lat;} else c1 = 'N';
	if(lon < 0) {c2 = 'E'; lon = -lon;} else c2 = 'W';
	y=(int)lat/60;
	x=(int)lon/60;
	lon=lon-((double)x*60.)+.5;
	lat=lat-((double)y*60.)+.5;

	sprintf(buf," % 2d%02d%c - % 3d%02d%c",y,(int)lon,c1,x,(int)lat,c2);
	CMainFrame::m_wndStatusBar.SetPaneText(1,buf);

	if(!GetDataOfPoint(lo,la,&klickSet)) goto setnull;

	sprintf(buf,"  %.1f hPa",(float)(klickSet.prmsl+9000)/10.f);
	CMainFrame::m_wndStatusBar.SetPaneText(2,buf);
	sprintf(buf," air %.1f C",(float)klickSet.temp/10.f);
	CMainFrame::m_wndStatusBar.SetPaneText(3,buf);
	
	sprintf(buf," sfc %.1f C",(float)klickSet.wtemp/10.f);
	CMainFrame::m_wndStatusBar.SetPaneText(9,buf);

	BYTE z=(BYTE)(((double)klickSet.wind/2.5+.5));
	sprintf(buf," wind: %d / %d Kn",beaufort[z],knots[z]);
	CMainFrame::m_wndStatusBar.SetPaneText(5,buf);
	sprintf(buf," humi: %d %%",(int)klickSet.rh);
	CMainFrame::m_wndStatusBar.SetPaneText(4,buf);
	if(klickSet.btcdc)
		{
		sprintf(buf," cloud: %d %%",(int)klickSet.btcdc);
		CMainFrame::m_wndStatusBar.SetPaneText(6,buf);
		}
	else CMainFrame::m_wndStatusBar.SetPaneText(6,"");

	if(klickSet.acpt)
		{
		sprintf(buf," precip.: %.1f mm/h",(float)klickSet.acpt/10.f);	
		CMainFrame::m_wndStatusBar.SetPaneText(7,buf);
		}
 	else CMainFrame::m_wndStatusBar.SetPaneText(7,"");

	if(klickSet.htsgw)
		{
		sprintf(buf," wave: %.1f m",(float)klickSet.htsgw/10.f);
		CMainFrame::m_wndStatusBar.SetPaneText(8,buf);
		}
	else CMainFrame::m_wndStatusBar.SetPaneText(8,"");
}


BOOL CMeteoView::OnEraseBkgnd(CDC* pDC) 
{
	//we do not need erease background;
	return(TRUE);
}


void CMeteoView::DoppelText(char *txt, int x, int y, COLORREF TCol, COLORREF FCol)
{
	RECT	Rect;
	long	i,j,len,xs,ys,xe,ye;

	len=(long)strlen(txt)*12;
	xs=(long)x-len; xe=(long)x+len; ys=(long)(y-12); ye=(long)(y+12);

	m_pDC->SetTextColor(FCol);

	for(i=-1; i<=1; i++)
		{
        for(j=-1; j<=1; j++)
			{
            if(!(i | j)) continue;
			Rect.left=xs+i; Rect.right=xe+i; Rect.top=ys+j; Rect.bottom=ye+j;
			m_pDC->DrawText(txt,&Rect,DT_CENTER | DT_VCENTER | DT_SINGLELINE);
		    }
		}
	m_pDC->SetTextColor(TCol);

	Rect.left=xs; Rect.right=xe; Rect.top=ys; Rect.bottom=ye;
	m_pDC->DrawText(txt,&Rect,DT_CENTER | DT_VCENTER | DT_SINGLELINE);
}

void CMeteoView::OnShowStation(int cx, int cy)
{
  	float		lon,lat;

	lon= ((float)lmapxoff + ((float)(swh - cx) * (float)lmapscale));
	lat= ((float)lmapyoff + ((float)(shh - cy) * (float)lmapscale));
	if(lat<-5400.f|| lat>5400.f || lon<-10800.f ||lon>10800.f) return;

	if(FirstSynopDate.stepswidth && MeteoDataSelection==1) ShowSynopStation(lon,lat);
	else ShowStation(lon,lat);
	
}

#include "MeteoKlickDlg.h"
void CMeteoView::ShowStation(float lon, float lat)
{
	int			x,y;
    char		c1,c2;
	CString		str,lab,preci,air,sfc;
	char		buf[1024];
	char		f;
	BMSDATA_SET klickSet; 


	if(!GetDataOfPoint(-(int)(lon),-(int)lat,&klickSet)) return;

	if(lat < 0) {c1 = 'S'; lat = -lat;} else c1 = 'N';
	if(lon < 0) {c2 = 'E'; lon = -lon;} else c2 = 'W';

	if(lat > 5400.f) lat = 5400.f;
	if(lon > 10800.f) lon = 10800.f;
	y=(int)lat/60;
	x=(int)lon/60;
	lon=lon-((float)x*60.f);
	lat=lat-((float)y*60.f);
	

	LoadString(5000,lab);
	str.Format("\n%s %2d%06.3f%c / %3d%06.3f%c\n\n",lab,y,lat,c1,x,lon,c2);
	LoadString(5001,lab);
	sprintf(buf,"%s %.1f hPa\n",lab,(float)(klickSet.prmsl+9000)/10.f);	str+=buf;
	LoadString(5002,lab);

	f='C';
	float fa=(float)klickSet.temp/10.f; 
	float fb=(float)klickSet.wtemp/10.f; 
	if(myBMS_Para.flag&1)
		{
		fa=(fa+273.15f)*1.8f-459.67f; 
		fb=(fb+273.15f)*1.8f-459.67f; 
		f='F';
		}
	LoadString(5024,air);
	LoadString(5025,sfc);
	sprintf(buf,"%s %s = %.1f%c : %s = %.1f%c\n",lab,air,fa,f,sfc,fb,f); 	str+=buf;

	if(klickSet.wind)
		{
		LoadString(5003,lab);
		BYTE z=(BYTE)(((float)klickSet.wind/2.5f+.5f));
		sprintf(buf,"%s %d beaufort = %.1f m/s = %d knots\n",lab
			,beaufort[z]
			,(float)klickSet.wind/10.f
			,knots[z]);	str+=buf;
		}
	if(klickSet.wdir<3600)
		{
		LoadString(5004,lab);
		sprintf(buf,"%s %.0f\n",lab,(float)klickSet.wdir/10.f);	str+=buf;
		}
	if(klickSet.rh)
		{
		LoadString(5005,lab);
		sprintf(buf,"%s %d %%\n",lab,(int)klickSet.rh);	str+=buf;
		}

	if(klickSet.acpt)
		{
		LoadString(5006,lab);
		sprintf(buf,"%s 100 %%\n",lab); str+=buf;
		LoadString(5009,lab);

		if(klickSet.pflag&FRC_RAIN) LoadString(5020,preci);
		if(klickSet.pflag&FRC_FRZR) LoadString(5021,preci);
		if(klickSet.pflag&FRC_ICEP) LoadString(5022,preci);
		if(klickSet.pflag&FRC_SNOW) LoadString(5023,preci);

		sprintf(buf,"%s %.1f mm/h   %s\n",lab,(float)klickSet.acpt/10.f,preci);
		str+=buf;
		}
	else
		{
		if(klickSet.btcdc>0 && klickSet.btcdc<120)
			{
			LoadString(5006,lab);
			sprintf(buf,"%s %d %%\n",lab,(int)klickSet.btcdc);	str+=buf;
			}
		}


	if(klickSet.htsgw||klickSet.wvdir)
		{
		LoadString(5007,lab);
		sprintf(buf,"%s %.2f m\n",lab,(float)klickSet.htsgw/10.f); str+=buf;
		LoadString(5008,lab);
		sprintf(buf,"%s %.0f\n",lab,(float)klickSet.wvdir/10.f);	str+=buf;
		}


	MeteoKlickDlg dlg(str.GetBuffer(0), this);
	dlg.DoModal();
}

void CMeteoView::ShowSynopStation(float lon, float lat)
{
    int			x,y;
    char		c1,c2;
	CString		str,lab,preci,air,sfc,sfa,sfb;
	char		buf[1024];
	char		synbuf[4096];
	char		f;
	BMSD_SYN	klickSet; 

	if(!GetSynopDataOfPoint(-(int)(lon),-(int)lat,&klickSet,synbuf)) return;


	lon=klickSet.lon;
	lat=klickSet.lat;

	if(lat < 0) {c1 = 'S'; lat = -lat;} else c1 = 'N';
	if(lon < 0) {c2 = 'E'; lon = -lon;} else c2 = 'W';

	if(lat > 5400.f) lat = 5400.f;
	if(lon > 10800.f) lon = 10800.f;
	y=(int)lat/60;
	x=(int)lon/60;
	lon=lon-((float)x*60.f);
	lat=lat-((float)y*60.f);
	

	LoadString(5000,lab);
	str.Format("\n%s %2d%02d%c / %3d%02d%c\n",lab,y,(int)lat,c1,x,(int)lon,c2);
	LoadString(5010,lab);
	sprintf(buf,"%s %s\n\n",lab,klickSet.station.Station);
	str+=buf;

	LoadString(5001,lab);
	sprintf(buf,"%s %.1f hPa\n",lab,(float)(klickSet.data.prmsl+9000)/10.f);	str+=buf;
	LoadString(5002,lab);

	f='C';
	float fa=(float)klickSet.data.temp/10.f; 
	float fb=(float)klickSet.data.wtemp/10.f; 
	if(myBMS_Para.flag&1)
		{
		fa=(fa+273.15f)*1.8f-459.67f; 
		fb=(fb+273.15f)*1.8f-459.67f; 
		f='F';
		}
	LoadString(5024,air);
	LoadString(5025,sfc);
	LoadString(5002,lab);

	if(klickSet.data.temp==-1280) sfa="?.?";
	else sfa.Format("%.1f",fa);
	if(klickSet.data.wtemp==-1280) sfb="?.?";
	else sfb.Format("%.1f",fb);

	sprintf(buf,"%s %s = %s%c : %s = %s%c\n",lab,air,sfa,f,sfc,sfb,f); 	str+=buf;

	if(klickSet.data.wind)
		{
		LoadString(5003,lab);
		BYTE z=(BYTE)(((float)klickSet.data.wind/2.5f+.5f));
		sprintf(buf,"%s %d beaufort = %.1f m/s = %d knots\n",lab
			,beaufort[z]
			,(float)klickSet.data.wind/10.f
			,knots[z]);	str+=buf;
		}
	if(klickSet.data.wdir<3600)
		{
		LoadString(5004,lab);
		sprintf(buf,"%s %.0f\n",lab,(float)klickSet.data.wdir/10.f);	str+=buf;
		}
	if(klickSet.data.rh)
		{
		LoadString(5005,lab);
		sprintf(buf,"%s %d %%\n",lab,(int)klickSet.data.rh);	str+=buf;
		}

	if(klickSet.data.acpt)
		{
		LoadString(5006,lab);
		sprintf(buf,"%s 100 %%\n",lab); str+=buf;
		LoadString(5009,lab);

		if(klickSet.data.pflag&FRC_RAIN) LoadString(5020,preci);
		if(klickSet.data.pflag&FRC_FRZR) LoadString(5021,preci);
		if(klickSet.data.pflag&FRC_ICEP) LoadString(5022,preci);
		if(klickSet.data.pflag&FRC_SNOW) LoadString(5023,preci);

		sprintf(buf,"%s %.1f mm/h   %s\n",lab,(float)klickSet.data.acpt/10.f,preci);	
		str+=buf;
		}
	else
		{
		if(klickSet.data.btcdc>0 && klickSet.data.btcdc<120)
			{
			LoadString(5006,lab);
			sprintf(buf,"%s %d %%\n",lab,(int)klickSet.data.btcdc);	str+=buf;
			}
		}

	if(klickSet.data.htsgw)
		{
		LoadString(5007,lab);
		sprintf(buf,"%s %.2f m\n",lab,(float)klickSet.data.htsgw/10.f); str+=buf;
		LoadString(5008,lab);
		sprintf(buf,"%s %.0f\n",lab,(float)klickSet.data.wvdir/10.f);	str+=buf;
		}


	MeteoKlickDlg dlg(str.GetBuffer(0), this);
	dlg.DoModal();

}

//select an item of the list of exist files
void CMeteoView::SetDate(int item) 
{
	myBMS_Para.refresch=-1; //force the redraw in the DrawingTools
	MeteoDataSelection=0;
	if(ExistDates.GetSize() && item!=-1)
		{
		SetCurrentMSDFile(item); //this set the new NowDate
		if(NowDate.type==2) NowDate.validtime=NowDate.validtime;
		// the basis time have +6 hours offset
		else NowDate.validtime=ExistDates[item].validtime-21600;
		MeteoDataSelection=1+item;
		}
	else NowDate.validtime=0;

  	myMainFrm->m_wndTimeToolBar.SetTimeInfo(0);
	myMainFrm->m_wndDlgBar.m_Details.SetPosibles();
	Invalidate();
}

void CMeteoView::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	int pos=GetScrollPos(SB_VERT);
	int	y=pos;
	int minpos,maxpos;
	int	xy;
	GetScrollRange(SB_VERT,&minpos, &maxpos); 
	double x=fullscale/lmapscale;

	switch(nSBCode)
	{
	case	SB_TOP:	
			pos=(int)((double)minpos*x);
			break;

	case	SB_BOTTOM:	
			pos=(int)((double)maxpos*x); 
			break;

	case	SB_LINEUP:
			xy=(int)((Y_ZoomFac/40.* lmapscale)+.5);
			if(xy<1) xy=1;
			pos=(int)(lmapyoff+(double)xy);

			break;

	case	SB_LINEDOWN:
			xy=(int)((Y_ZoomFac/40.* lmapscale)+.5);
			if(xy<1) xy=1;
			pos=(int)(lmapyoff-(double)xy);
			break;

	case	SB_ENDSCROLL:	//End scroll.
			MouseDown=0;
			Invalidate();
			return;

	case	SB_PAGEDOWN:
			xy=(int)((Y_ZoomFac/4.* lmapscale)+.5);
			if(xy<1) xy=1;
			pos=(int)(lmapyoff-(double)xy);
			break;

	case	SB_PAGEUP:
			xy=(int)((Y_ZoomFac/4.* lmapscale)+.5);
			if(xy<1) xy=1;
			pos=(int)(lmapyoff+(double)xy);
			break;

	case	SB_THUMBPOSITION: //Scroll to absolute position. The current position is specified by the nPos parameter.
			pos=nPos;
			pos=-(int)((double)pos*x);
			break;

	case	SB_THUMBTRACK:	// Drag scroll box to specified position. The current position is specified by the nPos parameter. 
			pos=nPos;
			pos=-(int)((double)pos*x);
			MouseDown=1;
			break;
	}


	lmapyoff = pos;
	chkscale(); 
}

void CMeteoView::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	int pos=GetScrollPos(SB_HORZ);
	int	y=pos;
	int minpos,maxpos;
	int	xy;
	GetScrollRange(SB_HORZ,&minpos, &maxpos); 
	double x=fullscale/lmapscale;

	MouseDown=1;

	switch(nSBCode)
	{
	case	SB_LEFT:		//Scroll to far left.
			pos=(int)((double)minpos*x); 
			break;

	case	SB_ENDSCROLL:	//End scroll.
			MouseDown=0;
			Invalidate();
			return;

	case	SB_LINELEFT:	//Scroll left.
			xy=(int)((X_ZoomFac/40.* lmapscale)+.5);
			if(xy<1) xy=1;
			pos=(int)(lmapxoff+(double)xy);
			break;

	case	SB_LINERIGHT:	//Scroll right.
			xy=(int)((X_ZoomFac/40.* lmapscale)+.5);
			if(xy<1) xy=1;
			pos=(int)(lmapxoff-(double)xy);
			break;

	case	SB_PAGELEFT:	//Scroll one page left.
			xy=(int)((X_ZoomFac/4.* lmapscale)+.5);
			if(xy<1) xy=1;
			pos=(int)(lmapxoff+(double)xy);
			break;

	case	SB_PAGERIGHT:	//Scroll one page right.
			xy=(int)((X_ZoomFac/4.* lmapscale)+.5);
			if(xy<1) xy=1;
			pos=(int)(lmapxoff-(double)xy);
			break;

	case	SB_RIGHT:		//Scroll to far right.
			pos=(int)((double)maxpos*x);
			break;

	case	SB_THUMBPOSITION: //Scroll to absolute position. The current position is specified by the nPos parameter.
			pos=nPos;
			pos=-(int)((double)pos*x);
			break;

	case	SB_THUMBTRACK:	// Drag scroll box to specified position. The current position is specified by the nPos parameter. 
			pos=nPos;
			pos=-(int)((double)pos*x);
			MouseDown=1;
			break;
	}

	lmapxoff = pos;
	chkscale(); 
}

void CMeteoView::OnStartBonitoProgram()
{
	if(myBMS_Para.MeteoComHWND)	
		{
		if(!::IsWindowVisible(myBMS_Para.MeteoComHWND))
			{
			::ShowWindow(myBMS_Para.MeteoComHWND,SW_SHOW);
			::SetForegroundWindow(myBMS_Para.MeteoComHWND);
			//b_meteocom.SetCheck(1);
			}
		else
			{
			::ShowWindow(myBMS_Para.MeteoComHWND,SW_HIDE);
			//b_meteocom.SetCheck(0);
			}
		}
	else
		{
		if(myBMS_Para.MeteoExecute[0])
			{
			myBMS_Para.meteocom_start=1;
			char	para[256];
			sprintf(para,"SW_SHOW,%d",(int) m_hWnd);
			ShellExecute(NULL, NULL,myBMS_Para.MeteoExecute,para,myBMS_Para.MeteoAccessDir, SW_SHOWNORMAL);	
			}
		}
}

int CMeteoView::PlottWorldBorder(CDC* pDC)
{

	char				fna[255];
	struct POINT_WIN	lwin;
	int					i;
	long				x,y,xs,xe,ys,ye;

	sprintf(fna,"%s\\CHARTDATA\\WORLDBORDER.LIN",myBMS_Para.MeteoAccessDir);
	if(!lh.Open(fna,CFile::modeRead|CFile::typeBinary, &le))
		{
		AfxMessageBox("OPEN ERROR CHARTDATA\\CWORLDBORDER.LIN");
		return(-1);
		}
	
	sprintf(fna,"%s\\CHARTDATA\\WORLDBORDER.WPN",myBMS_Para.MeteoAccessDir);
	if(!wh.Open(fna,CFile::modeRead|CFile::typeBinary, &we))
		{
		lh.Abort();
		AfxMessageBox("OPEN ERROR CHARTDATA\\WORLDBORDER.WPN");
		return(-1);
		}

	int r2x=pDC->SetROP2(R2_COPYPEN);//R2_MASKPENNOT   ); //(R2_COPYPEN); //R2_XORPEN);

	for(;;)
		{
		if(wh.Read(&lwin,sizeof(struct POINT_WIN))!=sizeof(POINT_WIN)) break;
		if(!lwin.len) break;
		if( lwin.ymax < cur_chart_window.ymin) continue;
		if((lwin.xmax < cur_chart_window.xmin)
		||(lwin.xmin > cur_chart_window.xmax)) continue;
		//if( lwin.ymin > cur_chart_window.ymax) break;
		xs=(long)((double)(((double)lwin.xmin/1000.)/lmapscale));
		ys=(long)((double)(((double)lwin.ymin/1000.)/lmapscale));
		xe=(long)((double)(((double)lwin.xmax/1000.)/lmapscale));
		ye=(long)((double)(((double)lwin.ymax/1000.)/lmapscale));
		if (xe>xs)	x=xe-xs;
		else		x=xs-xe;
		if (ye>ys)	y=ye-ys;
		else		y=ys-ye;
		if(y<4 && x<4) continue;

		if(lwin.len>1024) lwin.len=1024;
		lh.Seek(lwin.coor_file_seekpos,CFile::begin);
		lh.Read(&PointIBuf[0],sizeof(struct POINT_NEWLINE)*lwin.len);
		for (i=0, lwin.len-1; i<lwin.len; i++)
			{
			PointOBuf[i].x=(int)((double)(((double)PointIBuf[i].lon/1000. + lmapxoff)/lmapscale))+swh;
			PointOBuf[i].y=(int)((double)(((double)PointIBuf[i].lat/1000. + lmapyoff)/lmapscale))+shh;
			if(PointOBuf[i].x>ClipMax)PointOBuf[i].x=ClipMax;
			if(PointOBuf[i].x<-ClipMax)PointOBuf[i].x=-ClipMax;
			if(PointOBuf[i].y>ClipMax)PointOBuf[i].y=ClipMax;
			if(PointOBuf[i].y<-ClipMax)PointOBuf[i].y=-ClipMax;
			}

		if(lwin.info_flag_2==1)
			{
			m_logpen.lopnStyle = PS_DASHDOTDOT;
			m_logpen.lopnColor = myPAL_P_FRAME;
			}
		else
			{
			if(lwin.info_flag_2==3)
				{
				m_logpen.lopnStyle = PS_SOLID;
				m_logpen.lopnColor = myPAL_P_FRAME;
				}
			else
				{
				m_logpen.lopnStyle = PS_SOLID;
				m_logpen.lopnColor = myPAL_P_FRAME;
				}
			}
		m_logpen.lopnWidth.x = m_logpen.lopnWidth.y = 1;
    	PlotLine(pDC, lwin.len);
		}
	pDC->SetROP2(r2x);

	lh.Close();
	wh.Close();
	return(0);
}

void CMeteoView::OnDestroy() 
{
	WriteMyProfileInt("MAP","DetailFlags",DetailFlags);
	WriteMyProfileInt("MAP","SynopDetailFlags",SynopDetailFlags);

	WriteMyProfileDouble("MAP","lmapxoff",lmapxoff);
	WriteMyProfileDouble("MAP","lmapyoff",lmapyoff);
	WriteMyProfileDouble("MAP","lmapscale",lmapscale);
	WriteMyProfileDouble("MAP","fullscale",fullscale);

	WriteMyProfileDouble("MAP","fix_lmapxoff",fix_lmapxoff);
	WriteMyProfileDouble("MAP","fix_lmapyoff",fix_lmapyoff);
	WriteMyProfileInt("MAP","fix_zoom",fix_zoom);
	WriteMyProfileInt("MAP","UTC_LOCAL",m_UTC);


	char profilename[256],buf[256];

	sprintf(profilename,"%s\\MeteoCom.ini",myBMS_Para.MeteoAccessDir);
	sprintf(buf,"%d\0",myBMS_Para.GridSize);
	WritePrivateProfileString("Settings","gridsize",buf,profilename);

	CView::OnDestroy();	
}


void CMeteoView::SetTime(int pos, int flag) 
{

	TimePos=pos;

	if(FirstSynopDate.stepswidth && MeteoDataSelection==1) 
		{
		if(pos<ExistDates.GetSize()) NowDate.validtime=ExistDates[pos].validtime;
		}
	if(flag)
		{
		myMainFrm->m_wndTimeToolBar.SetTime(pos);
		}

	Invalidate();
}

void CMeteoView::OnSetFixZoom()
{
	if(lastcontextpoint.x==-1 && lastcontextpoint.y==-1)
		{
		if(!fix_zoom)
			{
			fix_lmapxoff=lmapxoff;
			fix_lmapyoff=lmapyoff;
			fix_zoom=1;
			}
		else 
			{
			fix_zoom=0;
			}
		}
	else
		{
		fix_lmapxoff = lmapxoff +((double)((double)swh - (double)lastcontextpoint.x) * lmapscale);
		fix_lmapyoff = lmapyoff +((double)((double)shh - (double)lastcontextpoint.y) * lmapscale);
		fix_zoom=1;
		lmapxoff=fix_lmapxoff;
		lmapyoff=fix_lmapyoff;
		chkscale(); 
		}

	lastcontextpoint.x=lastcontextpoint.y=-1;
}

void CMeteoView::OnContextMenu(CWnd*, CPoint point)
{
	lastcontextpoint=point;
	ScreenToClient(&lastcontextpoint);

	CMenu menu;
	VERIFY(menu.LoadMenu (IDR_VIEW_NAVMENUE));
	CMenu* pPopup = menu.GetSubMenu(0);
	ASSERT(pPopup != NULL);
	pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, point.x, point.y,myMainFrm); 
}

void CMeteoView::OnCopyText()
{
	BeginWaitCursor(); 
	DecodeMPfromClipBoard(m_hWnd);
	EndWaitCursor(); 
}

void CMeteoView::SetSymbolsSize(int size)
{
	SetGridDimension(size,1);

	LOGFONT	lf=			{
					   -8,	//lfHeight;
						0,	//lfWidth;
						0,	//lfEscapement;
						0,	//lfOrientation;
				FW_NORMAL,	//lfWeight;
						0,	//lfItalic;
						0,	//lfUnderline;
						0,	//lfStrikeOut;
						0,	//lfCharSet;
						0,	//lfOutPrecision;
						0,	//lfClipPrecision;
						0,	//lfQuality;
VARIABLE_PITCH | FF_SWISS,	//lfPitchAndFamily;
			{"Arial\0"}};	//lfFaceN


	lf.lfHeight=myDrawPara.FIG_HEIGHT;
	lf.lfWeight=myDrawPara.FIG_WEIGHT;
	myFond.Detach();
	myFond.CreateFontIndirect(&lf);
	myMainFrm->m_wndDlgBar.m_Details.SetSymbButton();
}
