// MeteoView.h : interface of the CMeteoView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_BONITO_METEO_LINKAGETESTVIEW)
#define AFX_BONITO_METEO_LINKAGETESTVIEW

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "MeteoTools.h"
#include "ChartDefs.h"
#include "DrawingTools.h"

class CMeteoView : public CView
{
protected: // Nur aus Serialisierung erzeugen
	CMeteoView();
	DECLARE_DYNCREATE(CMeteoView)

// Attribute
public:

	
// Operationen
public:
	
	void	SetStatusText(int x, int y);
	int		PlottChart(CDC* pDC);
	int		Filplot_chart_vec(CDC* pDC,long seek_window,int plane);
	void	PlotLine(CDC* pDC,int len);
	void	PlotPolygon(CDC* pDC,int len,int style);
	void	chkscale(void);
	void	Zoom(int xmin, int xmax, int ymin, int ymax, UINT key);
	void	SetMeteoCoordinates(); 
	void	SetMyScrollPos(); 

	void	PlottObjektLines(CDC* pDC);
	void	PlotOjects(CDC* pDC, int obj);

	void	DoppelText(char *txt, int x, int y, COLORREF TCol, COLORREF FCol);
	void	OnShowStation(int cx, int cy);
	void	ShowStation(float lon, float lat);
    void	ShowSynopStation(float lon, float lat);
	void	SetDate(int item);
	int		PlottWorldBorder(CDC* pDC);
	void	DrawData(CDC* pDC);
	void	SetColors();
	void	RecalcLayout();
	void	SetTime(int pos, int flag=0);
	void	SetSymbolsSize(int size=0);



	DrawingTools	myDrawTool;

// berladungen
	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CMeteoView)
	public:
	virtual void OnDraw(CDC* pDC);  // berladen zum Zeichnen dieser Ansicht
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnInitialUpdate();
	afx_msg void OnCopyText();

	//}}AFX_VIRTUAL

// Implementierung
public:	
	virtual ~CMeteoView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generierte Message-Map-Funktionen
protected:
	afx_msg void OnContextMenu(CWnd*, CPoint point);
	//{{AFX_MSG(CMeteoView)
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);

	afx_msg void OnDestroy();
	//}}AFX_MSG
public:	
	afx_msg void OnZoomADD();
	afx_msg void OnZoomDOWN();
	afx_msg void OnZoomLEFT();
	afx_msg void OnZoomSUB();
	afx_msg void OnZoomHOME();
	afx_msg void OnZoomRIGHT();
	afx_msg void OnZoomUP();
	afx_msg void OnSetFixZoom();
	afx_msg void OnStartBonitoProgram();
protected:

	DECLARE_MESSAGE_MAP()

public:	

	LOGPEN		m_logpen;
	LOGBRUSH	m_logbrush;
	CDC*		m_pDC;

	short		Screen_ymin;
	short		Screen_xmin;
	short		Screen_ymax;
	short		Screen_xmax;
	CPen		*WFPen,*WTPen;
	HBITMAP		m_fine_raster;

	CFile					OBJFile;
	CFileException			lo;
	struct BOYObject		OBJ_OBJ;
	struct BOYHeader		OBJ_HDR;
	struct BOYObjectPointer OBJ_PTR;
	double					ObjectScale;
	int						ObjectOffsetX,ObjectOffsetY;

	struct		COORDINAT_WIN cur_chart_window;
	double		lmapscale;		//Nav_Map Skalierung
	double		lmapxoff;		//Nav_Map X-Offset
	double		lmapyoff;		//Nav_Map Y-Offset
	double		X_ZoomFac, Y_ZoomFac,fullscale,min_scale;
	int			swh,shh;
	int			fix_zoom;
	double		fix_lmapxoff,fix_lmapyoff;
	CFileException	le,we;
	CFile		lh,wh;
	CRect		ViewRect;
	CPoint		c_last,c_down;
	BOOL		ZoomFlag;
	CSize		sizeTotal;
	CPoint		m_TopLeftZoom,m_BotRightZoom;
	CWnd*		m_mouse_Cwnd;
	CRect		MeteoRect;
	int			ViewRect_X,ViewRect_Y;
	double		Centimeter;
	int			ClipMax;
	int			printerflag;
	
	int			beaufort[256],knots[256]; 
	int			TimePos;
	int			N_TimePos;
	double		N_scale;
	double		N_xoff;
	double		N_yoff;
	CFont		myFond;
	COLORREF    myPAL_P_FRAME;
	CPoint		lastcontextpoint;


};

#define CTOP(cp) (int)(Centimeter * cp) 

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_BONITO_METEO_LINKAGETESTVIEW)
