// MyNavToolbar.cpp : implementation file
//
// This is a part of the Microsoft Foundation Classes C++ library.
// Copyright (C) 1992-1998 Microsoft Corporation
// All rights reserved.
//
// This source code is only intended as a supplement to the
// Microsoft Foundation Classes Reference and related
// electronic documentation provided with the library.
// See these sources for detailed information regarding the
// Microsoft Foundation Classes product.

#include "stdafx.h"
#include "GlobalTools.h"
#include "MyNavToolbar.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


#define FIXPOINT	7	//IDC_FIXPOINT
#define SLIDER		8	//ID_ZOOMSLIDER

/////////////////////////////////////////////////////////////////////////////
// CMyNavToolbar

CMyNavToolbar::CMyNavToolbar()
{
}

CMyNavToolbar::~CMyNavToolbar()
{
}

BEGIN_MESSAGE_MAP(CMyNavToolbar, CToolBar)
	//{{AFX_MSG_MAP(CMyNavToolbar)
	ON_WM_VSCROLL()
	ON_WM_CTLCOLOR()
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMyNavToolbar message handlers

BOOL CMyNavToolbar::Init(CWnd* pParentWnd)
{
	if (!CreateEx(pParentWnd, TBSTYLE_FLAT,WS_CHILD | WS_VISIBLE 
		| CBRS_TOOLTIPS | CBRS_ALIGN_RIGHT | CBRS_NOALIGN,CRect(1,1,1,1),IDR_NAVTOOLBAR) || !LoadToolBar(IDR_NAVTOOLBAR)) return -1; 

	if (!mySlider.Create(WS_CHILD|WS_VISIBLE|SBS_VERT,CRect(0,0,14,524),this,796)) return FALSE;

	SCROLLINFO info;
	info.cbSize = sizeof(SCROLLINFO);     
	info.fMask = SIF_ALL;     
	info.nMin = 0;     
	info.nMax = 100; 
	info.nPage =2;     
	info.nPos = 0;    
	info.nTrackPos = 1; 
	mySlider.SetScrollInfo(&info);

	SetSize();
	return TRUE;
}

void CMyNavToolbar::SetSize() 
{
	CRect rect;	

	if (mySlider.GetSafeHwnd() && myMeteoView->GetSafeHwnd())
		{
		myMeteoView->GetClientRect(rect);
		int cx=rect.Height();
		GetItemRect(SLIDER, rect);
		int z=cx-rect.bottom+32;
		mySlider.SetWindowPos(NULL,rect.left+5,rect.top+3,14,z, SWP_NOZORDER|SWP_NOACTIVATE|SWP_NOCOPYBITS);
		}
}

void CMyNavToolbar::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	int	pos=mySlider.GetScrollPos();

	switch(nSBCode)
	{
	case	SB_LEFT:		//Scroll to far left.
			pos=(pos/10)*10;
			pos-=10; 
			break;

	case	SB_ENDSCROLL:	//End scroll.
			if(MouseDown==2)
				{
				MouseDown=0;
				myMeteoView->Invalidate();
				}
			return;

	case	SB_LINELEFT:	//Scroll left.
			pos-=1;
			break;

	case	SB_LINERIGHT:	//Scroll right.
			pos+=1;
			break;

	case	SB_PAGELEFT:	//Scroll one page left.
			pos=(pos/20)*20;
			pos-=20;
			break;

	case	SB_PAGERIGHT:	//Scroll one page right.
			pos=(pos/20)*20;
			pos+=20;
			break;

	case	SB_RIGHT:		//Scroll to far right.
			pos=(pos/10)*10;
			pos+=10;
			break;

	case	SB_THUMBPOSITION: //Scroll to absolute position. The current position is specified by the nPos parameter.
			pos=nPos;

			break;

	case	SB_THUMBTRACK:	// Drag scroll box to specified position. The current position is specified by the nPos parameter. 
			MouseDown=1;
			pos=nPos;
			break;
	}

	if(pos<0) pos=0;
	if(pos>100) pos=100;
	SetZoom(pos);
	
}

int CMyNavToolbar::GetZoom()
{
	return mySlider.GetScrollPos();
}

void CMyNavToolbar::SetZoom(int pos)
{
	 if(myMeteoView->GetSafeHwnd())
		{
		if(pos>0) 	myMeteoView->lmapscale=myMeteoView->fullscale/100.*(double)pos;
		else myMeteoView->lmapscale=myMeteoView->min_scale; //fullscale/100.*(double).5;
		if(myMeteoView->fix_zoom)
			{
			myMeteoView->lmapxoff=myMeteoView->fix_lmapxoff;
			myMeteoView->lmapyoff=myMeteoView->fix_lmapyoff;
			}
		myMeteoView->chkscale(); 
		}
	
	mySlider.SetScrollPos(pos);
}	

void CMyNavToolbar::SetPos()
{
	if(!mySlider.GetSafeHwnd() || !myMeteoView->GetSafeHwnd()) return;
	mySlider.SetScrollPos((int)(myMeteoView->lmapscale/myMeteoView->fullscale*100.));
}

