// MyTimeToolbar.cpp : implementation file
//
// This is a part of the Microsoft Foundation Classes C++ library.
// Copyright (C) 1992-1998 Microsoft Corporation
// All rights reserved.
//
// This source code is only intended as a supplement to the
// Microsoft Foundation Classes Reference and related
// electronic documentation provided with the library.
// See these sources for detailed information regarding the
// Microsoft Foundation Classes product.

#include "stdafx.h"
#include "GlobalTools.h"
#include "MyTimeToolbar.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define METEOCOM	0
#define PRINTER		1
#define SPEED_MINUS	2 //ID_SPEED_MINUS
#define DATE_RPLAY	5 //ID_DATE_RPLAY
#define DATE_PLAY	6 //ID_DATE_PLAY
#define SET_UTC		7 //IDC_SET_UTC
#define DATE		8 //ID_DATE
#define SLIDER		9 //ID_DATE_SLIDER



/////////////////////////////////////////////////////////////////////////////
// CMyTimeToolbar

CMyTimeToolbar::CMyTimeToolbar()
{
	CTimeUTC tim;
	myLastTime=tim.GetFullHours(3);
	hoursteps=3;
	DAT_slide_max=0;
	DAT_LastTime=myLastTime;
}

CMyTimeToolbar::~CMyTimeToolbar()
{
	WriteMyProfileInt("MAP","UTC_LOCAL",m_UTC);
}

BEGIN_MESSAGE_MAP(CMyTimeToolbar, CToolBar)
	//{{AFX_MSG_MAP(CMyTimeToolbar)
	ON_WM_HSCROLL()
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMyTimeToolbar message handlers

BOOL CMyTimeToolbar::Init(CWnd* pParentWnd)
{
	if (!CreateEx(pParentWnd, TBSTYLE_FLAT,WS_CHILD | WS_VISIBLE | CBRS_TOP| CBRS_TOOLTIPS|CBRS_FLYBY | CBRS_SIZE_DYNAMIC) 
		|| !LoadToolBar(IDR_BONITO_METEO_FRAME)) return -1; 

	if (!mySlider.Create(WS_CHILD|WS_VISIBLE,CRect(0,0,600,16),this,998)) return FALSE;
	//SetBarStyle(GetBarStyle()&~(CBRS_GRIPPER|CBRS_BORDER_ANY));

	myDate.Create("28.Dec.  12:00", WS_CHILD|WS_VISIBLE|SS_CENTER|SS_CENTERIMAGE,CRect(0,5,113,28),this);

	NowDate.validtime=time(0);
	SetSlideTimeInfo();
	SetWidth();

	return TRUE;
}

void CMyTimeToolbar::ResetTimeInfo()
{
	SetSlideTimeInfo(DAT_slide_max,DAT_LastTime);
}

void CMyTimeToolbar::SetTimeInfo(int m_ACTIV, int max, time_t newtime,int pos)
{
	SetSlideTimeInfo(max,newtime,pos);
}

void CMyTimeToolbar::SetSlideTimeInfo(int max, time_t newtime, int pos)
{
	int z=0;
	if(FirstSynopDate.stepswidth) z=1;


	int x=FirstSynopDate.stepswidth;
	if(MeteoDataSelection>z && (ExistDates.GetSize()-x))
		{
		x+=MeteoDataSelection-z-1;
		SetCurrentMSDFile(x);
		}
	else 
		{
		SetCurrentMSDFile(0);
		}
			
	if(max==-1) 
		{
		if(FirstSynopDate.stepswidth && MeteoDataSelection==1) max=FirstSynopDate.stepswidth;
		else
			{
			if(NowDate.type==2) max=0;
			else max=NowDate.stepswidth;
			}
		}
	if(newtime==-1) 
		{
		if(FirstSynopDate.stepswidth && MeteoDataSelection==1) newtime=FirstSynopDate.validtime;
		else 
			{
			//if email bulletin
			if(NowDate.type==2) 
				{
				newtime=NowDate.validtime; //+ because -+64800
				}
			else newtime=NowDate.validtime-21600; //minus the first 6 Hours
			}
		}
	DAT_slide_max=max;
	DAT_LastTime=newtime;
	if(pos==-1)
		{
		if(myMeteoView && myMeteoView->N_TimePos!=-1) pos=myMeteoView->N_TimePos;
		else pos=0;
		}	

	
	slide_max=max;
	NowDate.validtime=newtime;

   SCROLLINFO info;
   info.cbSize = sizeof(SCROLLINFO);     
   info.fMask = SIF_ALL;     
   info.nMin = slide_min=0;     
   info.nMax = max; 
   if(max>48) info.nPage =3;
   else info.nPage =1;
   info.nPos = pos;    
   info.nTrackPos = 1; 
   mySlider.SetScrollInfo(&info);

   SetTime(pos,newtime); 
}


BOOL CMyTimeToolbar::SetWidth()
{
	CRect rect;	
	
	SetButtonInfo(DATE		, ID_SEPARATOR	, TBBS_BUTTON   , 20);
	SetButtonInfo(SLIDER	, ID_SEPARATOR	, TBBS_SEPARATOR, 3200);

	CTimeUTC tim(NowDate.validtime);
	
	if (mySlider.m_hWnd != NULL)
		{
		GetItemRect(SLIDER, rect);
		mySlider.SetWindowPos(NULL, rect.left+203, rect.top+2, 14, 200, SWP_NOZORDER|SWP_NOACTIVATE|SWP_NOCOPYBITS);
		}

	
	if (myDate.m_hWnd != NULL)
		{
		GetItemRect(DATE, rect);
		myDate.SetWindowPos(NULL, rect.left+1, rect.top+1, 0, 0, SWP_NOZORDER|SWP_NOACTIVATE|SWP_NOSIZE);
		myDate.SetWindowText(tim.Format("%d.%b %H:%M"));
		}
	SetSize();
	SetAnimatButton();
	return TRUE;
}

void CMyTimeToolbar::SetAnimatButton()
{
	/*CToolBarButton* A;

	A= GetButton(DATE_PLAY);
	if(A)
		{
		if(myMainFrm->m_wndLeftBar.m_tabwin.m_tab0.m_play) A->m_nStyle=TBBS_CHECKED;
		else A->m_nStyle=0;
		}
	A= GetButton(DATE_RPLAY);
	if(A)
		{
		if(myMainFrm->m_wndLeftBar.m_tabwin.m_tab0.m_rplay) A->m_nStyle=TBBS_CHECKED;
		else A->m_nStyle=0;
		}*/
	Invalidate();

}

void CMyTimeToolbar::SetTime(int pos, time_t lasttime) 
{
	CTimeUTC tim;
	if(!lasttime) 
		{
		lasttime=NowDate.validtime;
		}

	if(!lasttime) return;


	if(FirstSynopDate.stepswidth && MeteoDataSelection==1)
		{
		tim=lasttime;
		}
	else
		{
		if(NowDate.type==2) tim=lasttime+(NowDate.hour*3600);
		else tim=lasttime+((6+pos)*3600);
		}

	if(!m_UTC) 
		{
		myDate.SetWindowText(tim.Format("%d.%b. %H:%M"));
		}
	else
		{
		myDate.SetWindowText(tim.FormatLocal("%d.%b. %H:%M"));
		}

	mySlider.SetScrollPos(pos);
	Invalidate();
}

void CMyTimeToolbar::SetSize() 
{
	CRect rect;	
	
	if (mySlider.GetSafeHwnd() && myMeteoView->GetSafeHwnd())
		{
		myMainFrm->GetClientRect(rect);
		int cx=rect.Width();
		GetItemRect(SLIDER, rect);
		int	z=cx-rect.left-100;
		if(z<100) z=100;
		if(z>=1680) z=1680;
		mySlider.SetWindowPos(NULL, rect.left+90, rect.top+3, z, 16, SWP_NOZORDER|SWP_NOACTIVATE);
		SetTime(mySlider.GetScrollPos());
		}
}

void CMyTimeToolbar::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	int	step,pos=mySlider.GetScrollPos();
	
	step=3;


	switch(nSBCode)
	{
	case	SB_LEFT:		//Scroll to far left.
			pos=(pos/12)*12;
			pos-=12; 
			break;

	case	SB_ENDSCROLL:	//End scroll.
			return;

	case	SB_LINELEFT:	//Scroll left.
			pos-=1;
			break;

	case	SB_LINERIGHT:	//Scroll right.
			pos+=1;
			break;

	case	SB_PAGELEFT:	//Scroll one page left.
			pos=(pos/24)*24;
			pos-=24;
			break;

	case	SB_PAGERIGHT:	//Scroll one page right.
			pos=(pos/24)*24;
			pos+=24;
			break;

	case	SB_RIGHT:		//Scroll to far right.
			pos=(pos/12)*12;
			pos-=12;
			break;

	case	SB_THUMBPOSITION: //Scroll to absolute position. The current position is specified by the nPos parameter.
			pos=nPos;
			break;

	case	SB_THUMBTRACK:	// Drag scroll box to specified position. The current position is specified by the nPos parameter. 
			pos=nPos;
			break;
	}

	if(pos<0) pos=0;
	if(pos>slide_max) pos=slide_max;
	mySlider.SetScrollPos(pos);

	if (myMeteoView->GetSafeHwnd())
		{
		myMeteoView->N_TimePos=-100;
		myMeteoView->SetTime(pos,1);
		}

}
