// PicFileRequester.cpp : implementation file
//

#include "stdafx.h"
#include "GlobalTools.h"
#include "PicFileRequester.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPicFileRequester

CPicFileRequester::CPicFileRequester()
{
	lastchanged=-1;
	m_bDragging=0;
}

CPicFileRequester::~CPicFileRequester()
{
}


BEGIN_MESSAGE_MAP(CPicFileRequester, CListCtrl)
	//{{AFX_MSG_MAP(CPicFileRequester)
	ON_WM_ERASEBKGND()
	ON_NOTIFY_REFLECT(LVN_ITEMCHANGED, OnItemchanged)
	ON_NOTIFY_REFLECT(LVN_BEGINDRAG,   OnBegindrag)
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_RBUTTONUP()
	ON_WM_CONTEXTMENU()
	ON_BN_CLICKED(ID_FAX_DELETE,		OnDelete)
	ON_BN_CLICKED(ID_FAX_RENAME,		OnRename)
	ON_BN_CLICKED(ID_FAX_DNL_FOLDER,	OnMoveDNL)
	ON_BN_CLICKED(ID_FAX_RX_FOLDER,		OnMoveRX)
	ON_BN_CLICKED(ID_FAX_SAT_FOLDER,	OnMoveSAT)
	ON_BN_CLICKED(ID_FAX_B1_FOLDER,		OnMoveB1)
	ON_BN_CLICKED(ID_FAX_B2_FOLDER,		OnMoveB2)
	ON_BN_CLICKED(ID_FAX_B3_FOLDER,		OnMoveB3)
	ON_BN_CLICKED(ID_FAX_TRASH,			OnMoveTrash)

	//}}AFX_MSG_MAP
//	ON_MESSAGE(WM_DRAGPIC,OnDragPic)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPicFileRequester message handlers

void CPicFileRequester::Init() 
{
	static init =0;

	if(!init)
		{
		mImageList.Create(FAX_LPIC_X+20,FAX_LPIC_Y+24,ILC_COLORDDB,0,16);
		SetImageList(&mImageList, LVSIL_STATE);

		LV_COLUMN	lvc;
		lvc.mask = LVCF_FMT | LVCF_WIDTH|LVCF_SUBITEM;
		lvc.fmt = LVCFMT_CENTER;
		lvc.iSubItem = -1;
		lvc.cx = FAX_LPIC_X+12;
		InsertColumn(0,&lvc);	

		LoadPictureList();
		}

}
BOOL CPicFileRequester::OnEraseBkgnd(CDC* pDC) 
{
	return CListCtrl::OnEraseBkgnd(pDC);
	


	CRect rect;
	GetClientRect(&rect);
	rect.right=148;
	pDC->FillSolidRect(rect,RGB(236,240,240));
	rect.left=rect.right;
	rect.right+=16;
	pDC->FillSolidRect(rect,RGB(200,224,240));
	return TRUE;
}

void CPicFileRequester::OnContextMenu(CWnd*, CPoint point)
{

	if(myPicFiles(m_folder).GetSize()<1) return;

	CMenu menu;
	VERIFY(menu.LoadMenu (IDR_POPUP_PICREQUESTER));
	CMenu* pPopup = menu.GetSubMenu(0);
	ASSERT(pPopup != NULL);

	switch(m_folder)
		{
		case FDIR_DNL: 		pPopup->RemoveMenu(ID_FAX_DNL_FOLDER, MF_BYCOMMAND);
							break;
		case FDIR_RX: 		pPopup->RemoveMenu(ID_FAX_RX_FOLDER, MF_BYCOMMAND);
							break;
		case FDIR_SAT: 		pPopup->RemoveMenu(ID_FAX_SAT_FOLDER, MF_BYCOMMAND);
							break;
		case FDIR_BANK1: 	pPopup->RemoveMenu(ID_FAX_B1_FOLDER, MF_BYCOMMAND);
							break;
		case FDIR_BANK2: 	pPopup->RemoveMenu(ID_FAX_B2_FOLDER, MF_BYCOMMAND);
							break;
		case FDIR_BANK3: 	pPopup->RemoveMenu(ID_FAX_B3_FOLDER, MF_BYCOMMAND);
							break;
		case FDIR_TRASH: 	pPopup->RemoveMenu(ID_FAX_TRASH, MF_BYCOMMAND);
							break;
		}

	pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, point.x, point.y,this); 
}


void CPicFileRequester::DrawItem(LPDRAWITEMSTRUCT di) 
{
	CRect		rect,rcAllLabels;
	int			nItem = di->itemID;
	BOOL		bFocus = (GetFocus() == this);
	LV_ITEM		lvi;

	if(m_folder<0 || m_folder>FDIR_MAX) return;
	if(nItem>=myPicFiles(m_folder).GetSize()) return;

	GetItemRect(nItem, rect, LVIR_BOUNDS);	

	lvi.mask = LVIF_IMAGE | LVIF_STATE;
	lvi.iItem = nItem;
	lvi.iSubItem = 0;
	lvi.stateMask = 0xFFFF;     // get all state flags
	GetItem(&lvi);

	BOOL bSelected = (bFocus || (GetStyle() & LVS_SHOWSELALWAYS)) && lvi.state & LVIS_SELECTED;
	bSelected = bSelected || (lvi.state & LVIS_DROPHILITED);

	//the following draws the little thumbnail picture
	//myImageView->picFolder and myImageView->picIndex is the picture in my view
	//DrawThumbFolders(di->hDC,nItem,rect,bSelected,m_folder,myImageView->picFolder,myImageView->picIndex);

	// for this example 
	// we simulated a picture in folder BANK1 and the top picture was viewed
	DrawThumbFolders(di->hDC,nItem,rect,bSelected,m_folder,FDIR_BANK1,0);

}

LPCTSTR CPicFileRequester::MakeShortString(CDC* pDC, LPCTSTR lpszLong, int nColumnLen, int nOffset)
{
	static const _TCHAR szThreeDots[] = _T("...");

	int nStringLen = lstrlen(lpszLong);

	if(nStringLen == 0 ||
		(pDC->GetTextExtent(lpszLong, nStringLen).cx + 2) <= nColumnLen)
	{
		return(lpszLong);
	}

	static _TCHAR szShort[MAX_PATH];

	lstrcpy(szShort,lpszLong);
	int nAddLen = pDC->GetTextExtent(szThreeDots,sizeof(szThreeDots)).cx;

	for(int i = nStringLen-1; i > 0; i--)
	{
		szShort[i] = 0;
		if((pDC->GetTextExtent(szShort, i).cx + nOffset + nAddLen)
			<= nColumnLen)
		{
			break;
		}
	}

	lstrcat(szShort, szThreeDots);
	return(szShort);
}


void CPicFileRequester::RefreschTheList(int xm_folder, char *findname)
	{
	if(xm_folder!=-1) m_folder=xm_folder;
	SetItemCountEx(myPicFiles(m_folder).GetSize(),NULL);

	if(findname)
		{
		m_index	= 0; 
		for(int i=0; i<myPicFiles(m_folder).GetSize(); i++)
			{
			if(!strcmp(findname,myPicFiles(m_folder)[i].filepath))
				{
				m_index=i; break;
				}
			}
		}
	SetListSelect(m_index);
}

void CPicFileRequester::SetListSelect(int sel, int set)
{
	int nCount = GetItemCount()-1;
	if(sel>nCount) sel=nCount;
	if(sel<0) sel=0;

	int top=GetTopIndex();
    int page=GetCountPerPage();
    int old=GetSelectionMark()-top;
    if(old>=page) old=page-1;
	if(old<0) old=0;
    	
    int c=sel-old; 
	if(c>=nCount) c=nCount-1;
	if(c<0) c=0;

	if(!(sel>=top && sel<=(top+page)) || !set)
		{
		int x=c+page-1; if(x>nCount) x=nCount-1;
		EnsureVisible(0,0);
		EnsureVisible(x,0);
		}

	SetItemState(GetSelectionMark(),0,LVIS_SELECTED|LVIS_FOCUSED);
	SetItemState(sel, LVIS_SELECTED|LVIS_FOCUSED,LVIS_SELECTED|LVIS_FOCUSED);
	SetSelectionMark(sel);
	m_index=sel;
}


void CPicFileRequester::OnItemchanged(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	*pResult = 0;

	m_index=lastchanged=pNMListView->iItem;
}

void CPicFileRequester::OnBegindrag(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW     *pnmListView = (NM_LISTVIEW *)pNMHDR;

	::SetCursor(myPicDropOK);
	m_hcur_actual=myPicDropOK;
    m_bDragging = TRUE;
	m_iItemDrag = pnmListView->iItem;
	SetCapture();
}

/*
LRESULT CPicFileRequester::OnDragPic(WPARAM wParam,LPARAM lParam)
{
	if(!m_bDragging) return FALSE;
	if(m_hcur_actual!=myPicDropOK)
		{
		::SetCursor(myPicDropOK);
		m_hcur_actual=myPicDropOK;
		}
	
	return TRUE;
}*/

void CPicFileRequester::OnMouseMove(UINT nFlags, CPoint point) 
{
	if (m_bDragging)
		{
		CPoint fpoint=point;
		ClientToScreen(&fpoint);
 		CWnd* pWnd = WindowFromPoint(fpoint);
		// Note: pWnd is temporary so don't store it!
		if (!pWnd) 
			{
			if(m_hcur_actual!=myPicNoDrop)
				{
				::SetCursor(myPicNoDrop);
				m_hcur_actual=myPicNoDrop;
				}
			return;
			}

		if (pWnd->m_hWnd == m_hWnd
		 || pWnd->m_hWnd == myMainFrm->m_wndDlgBar.m_Images.b_DNL.m_hWnd
		 || pWnd->m_hWnd == myMainFrm->m_wndDlgBar.m_Images.b_RX.m_hWnd
		 || pWnd->m_hWnd == myMainFrm->m_wndDlgBar.m_Images.b_F1.m_hWnd
		 || pWnd->m_hWnd == myMainFrm->m_wndDlgBar.m_Images.b_F2.m_hWnd
		 || pWnd->m_hWnd == myMainFrm->m_wndDlgBar.m_Images.b_F3.m_hWnd
		 || pWnd->m_hWnd == myMainFrm->m_wndDlgBar.m_Images.b_TRASH.m_hWnd
		 || pWnd->m_hWnd == myMainFrm->m_wndDlgBar.m_Images.b_SAT.m_hWnd)
			{
			if(m_folder==FDIR_DNL   && pWnd->m_hWnd == myMainFrm->m_wndDlgBar.m_Images.b_DNL.m_hWnd) goto setno;
			if(m_folder==FDIR_RX    && pWnd->m_hWnd == myMainFrm->m_wndDlgBar.m_Images.b_RX.m_hWnd) goto setno;
			if(m_folder==FDIR_BANK1 && pWnd->m_hWnd == myMainFrm->m_wndDlgBar.m_Images.b_F1.m_hWnd) goto setno;
			if(m_folder==FDIR_BANK2 && pWnd->m_hWnd == myMainFrm->m_wndDlgBar.m_Images.b_F2.m_hWnd) goto setno;
			if(m_folder==FDIR_BANK3 && pWnd->m_hWnd == myMainFrm->m_wndDlgBar.m_Images.b_F3.m_hWnd) goto setno;
			if(m_folder==FDIR_TRASH && pWnd->m_hWnd == myMainFrm->m_wndDlgBar.m_Images.b_TRASH.m_hWnd) goto setno;
			if(m_folder==FDIR_SAT   && pWnd->m_hWnd == myMainFrm->m_wndDlgBar.m_Images.b_SAT.m_hWnd) goto setno;

			if(m_hcur_actual!=myPicDropOK) 
				{
				::SetCursor(myPicDropOK);
				m_hcur_actual=myPicDropOK;
				}
			}
		else 
			{
setno:
			if(m_hcur_actual!=myPicNoDrop)
				{
				::SetCursor(myPicNoDrop);
				m_hcur_actual=myPicNoDrop;
				}
			}

		}


	CListCtrl::OnMouseMove(nFlags, point);
}

void CPicFileRequester::OnButtonUp(CPoint point)
{
	int	x_folder=-1;

	if (m_bDragging)  // end of the drag operation
		{
		::ReleaseCapture();
		CPoint fpoint=point;
		ClientToScreen(&fpoint);
 		CWnd* pWnd = WindowFromPoint(fpoint);
		// Note: pWnd is temporary so don't store it!
		m_bDragging = FALSE;
		// Restore the cursor, etc.
		m_hcur_actual=::SetCursor(NULL);
		::SetCursor(m_hcur_actual);

		if (pWnd->m_hWnd == m_hWnd) return;
		if (pWnd->m_hWnd == myMainFrm->m_wndDlgBar.m_Images.b_DNL.m_hWnd
		 || pWnd->m_hWnd == myMainFrm->m_wndDlgBar.m_Images.b_RX.m_hWnd
		 || pWnd->m_hWnd == myMainFrm->m_wndDlgBar.m_Images.b_F1.m_hWnd
		 || pWnd->m_hWnd == myMainFrm->m_wndDlgBar.m_Images.b_F2.m_hWnd
		 || pWnd->m_hWnd == myMainFrm->m_wndDlgBar.m_Images.b_F3.m_hWnd
		 || pWnd->m_hWnd == myMainFrm->m_wndDlgBar.m_Images.b_TRASH.m_hWnd
		 || pWnd->m_hWnd == myMainFrm->m_wndDlgBar.m_Images.b_SAT.m_hWnd)
			{
			if(pWnd->m_hWnd == myMainFrm->m_wndDlgBar.m_Images.b_DNL.m_hWnd) x_folder=FDIR_DNL;
			if(pWnd->m_hWnd == myMainFrm->m_wndDlgBar.m_Images.b_RX.m_hWnd) x_folder=FDIR_RX;
			if(pWnd->m_hWnd == myMainFrm->m_wndDlgBar.m_Images.b_F1.m_hWnd) x_folder=FDIR_BANK1;
			if(pWnd->m_hWnd == myMainFrm->m_wndDlgBar.m_Images.b_F2.m_hWnd) x_folder=FDIR_BANK2;
			if(pWnd->m_hWnd == myMainFrm->m_wndDlgBar.m_Images.b_F3.m_hWnd) x_folder=FDIR_BANK3;
			if(pWnd->m_hWnd == myMainFrm->m_wndDlgBar.m_Images.b_TRASH.m_hWnd) x_folder=FDIR_TRASH;
			if(pWnd->m_hWnd == myMainFrm->m_wndDlgBar.m_Images.b_SAT.m_hWnd) x_folder=FDIR_SAT;
			if(x_folder==m_folder) return;

			MovePicFile(m_iItemDrag,m_folder,x_folder); 
			Invalidate();
			}
		}
}
void CPicFileRequester::OnRButtonUp(UINT nFlags, CPoint point) 
{
	OnButtonUp(point);	
	CListCtrl::OnRButtonUp(nFlags, point);
}
void CPicFileRequester::OnLButtonUp(UINT nFlags, CPoint point) 
{
	OnButtonUp(point);
	CListCtrl::OnLButtonUp(nFlags, point);
}

void CPicFileRequester::OnDelete()		{DeletePicFile(m_index,m_folder); Invalidate();}
void CPicFileRequester::OnMoveDNL()		{MoveTo(FDIR_DNL);}
void CPicFileRequester::OnMoveRX()		{MoveTo(FDIR_RX);}
void CPicFileRequester::OnMoveSAT()		{MoveTo(FDIR_SAT);}
void CPicFileRequester::OnMoveB1()		{MoveTo(FDIR_BANK1);}
void CPicFileRequester::OnMoveB2()		{MoveTo(FDIR_BANK2);}
void CPicFileRequester::OnMoveB3()		{MoveTo(FDIR_BANK3);}
void CPicFileRequester::OnMoveTrash()	{MoveTo(FDIR_TRASH);}

#include "RenameDlg.h"
void CPicFileRequester::OnRename()		
{
	CRenameDlg dlg(this,myPicFiles(m_folder)[m_index].filepath);
	if(dlg.DoModal()==IDOK)
		{
		RenamePicFileName(m_index,m_folder,MakeFileName(myPicFiles(m_folder)[m_index].filepath));
		Invalidate();
		}
}


void CPicFileRequester::MoveTo(int folder)
{
	MovePicFile(m_index,m_folder,folder);
	Invalidate();
}

char *CPicFileRequester::MakeFileName(char *file)
{
	int i;
	for(i=(int)strlen(file)-1; i>=0; i--)
		{
		if(file[i]=='\\') {i++; break;}
		}
	return &file[i];
}
