
// TimeUtc.h
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(MY_UTC_TIME)
#define MY_UTC_TIME



class CTimeUTC
{
public:

// Constructors

	CTimeUTC();
	CTimeUTC(time_t ti);
	CTimeUTC(const CTimeUTC& timeSrc);
	CTimeUTC(const CTime& timeSrc);
	CTimeUTC(int nYear, int nMonth, int nDay, int nHour, int nMin, int nSec);

	CTimeUTC(const SYSTEMTIME& sysTime);
	CTimeUTC(const FILETIME& fileTime);
	const CTimeUTC& operator=(const CTimeUTC& timeSrc);
	const CTimeUTC& operator=(time_t t);
	static CTimeUTC PASCAL GetCurrentTime();
	BOOL GetAsSystemTime(SYSTEMTIME& timeDest) const;

// Attributes

	time_t GetTime();
	int GetYear();
	int GetMonth();       // month of year (1 = Jan)
	int GetDay();         // day of month
	int GetHour();
	int GetMinute();
	int GetSecond();


	time_t GetLocalTime();
	int GetLocalYear();
	int GetLocalMonth();  // month of year (1 = Jan)
	int GetLocalDay();    // day of month
	int GetLocalHour();
	int GetLocalMinute();
	int GetLocalSecond();
	int GetLocalDayOfWeek(); // 1=Sun, 2=Mon, ..., 7=Sat

	static int cDaysInMonth[];
	time_t AddHours(int hours,time_t tref=NULL);
	time_t SubHours(int hours,time_t tref=NULL);

	static double PASCAL GetDoubleTime(time_t ti);
	static time_t PASCAL GetFileTime(FILETIME &fileTime, double *dbl);
	static time_t PASCAL GetFileTime(CTime &tim, double *dbl);

// Operations
	// time math
	CTimeSpan operator-(CTimeUTC time) const;
	CTimeUTC operator-(CTimeSpan timeSpan) const;
	CTimeUTC operator+(CTimeSpan timeSpan) const;
	const CTimeUTC& operator+=(CTimeSpan timeSpan);
	const CTimeUTC& operator-=(CTimeSpan timeSpan);

	const time_t operator+=(time_t t);
	const time_t operator-=(time_t t);

	BOOL operator==(CTimeUTC time) const;
	BOOL operator!=(CTimeUTC time) const;
	BOOL operator<(CTimeUTC time) const;
	BOOL operator>(CTimeUTC time) const;
	BOOL operator<=(CTimeUTC time) const;
	BOOL operator>=(CTimeUTC time) const;

	// formatting using "C" strftime
	CString FormatGMT(LPCTSTR pFormat) const;
	CString FormatLocal(LPCTSTR pFormat) const;
	CString Format(LPCTSTR pFormat) const;
	CString Format(time_t my_time, LPCTSTR pFormat) const;


	time_t	MakeUTCTime(int wYear, int wMonth, int wDay,int wHour, int wMinute, int wSecond);
	time_t	MakeLocalTime(int wYear, int wMonth, int wDay,int wHour, int wMinute, int wSecond);
	void	SetMyTime(time_t ti=NULL);
	time_t  getSynopTime(int wDay, int wHour, int wMinute);
	time_t	GetFullHours(int mask=1);


	time_t	m_time;
	
	double	dbl_time;
	int		m_year;
	int     m_mon;
	int		m_day;
	int		m_hour;
	int		m_min;
	int		m_sec;

};

#endif //MY_UTC_TIME